CREATE OR REPLACE FUNCTION mate_gain(integer,varchar) RETURNS SETOF numeric AS' --entropia,clase
DECLARE
	
	sum		integer;
	sum1		integer;
	
	Gan		numeric;
	val_fraccion	numeric;
	val_entro	numeric;
	val_ln2		numeric := 0.69314718055994530942; 

	att		varchar DEFAULT '''';
	cad		varchar DEFAULT NULL;
	cad1		varchar DEFAULT NULL;
	txt		varchar DEFAULT '''';
		
	Ent		numeric;
	
	rec1		record;
	
BEGIN
				
		txt := ''SELECT att FROM pg_pila'';
		FOR rec1 IN EXECUTE txt LOOP
			IF cad ISNULL THEN
				cad := ''attname !=''''''||rec1.att||'''''''';
			ELSE
				cad := cad ||'' AND attname !=''''''||rec1.att||'''''''';
			END IF;
			att := rec1.att;
		END LOOP;
		
		txt := ''SELECT attname FROM pg_class,pg_attribute WHERE ''
			 ||''pg_class.relname=''''kdd_ent''''''	
			 || '' AND pg_attribute.attrelid =  pg_class.oid AND ''||cad||'' AND attnum >0 ORDER BY attnum'';
		cad := NULL;
		
		FOR rec1 IN EXECUTE txt LOOP
			IF cad ISNULL THEN
				cad := rec1.attname||''=-1'';
			ELSE
				cad := cad||'' AND ''||rec1.attname||''=-1'';
			END IF;
		END LOOP;
		
		IF cad ISNULL THEN
			txt := ''SELECT SUM(count) AS suma FROM viewc1 WHERE ''||att||''!=''''-1'''''';
		ELSE
			txt := ''SELECT SUM(count) AS suma FROM viewc1 WHERE ''||cad||'' AND ''||att||''!=''''-1'''''';
		END IF;
		
		FOR rec1 IN EXECUTE txt LOOP
			sum := rec1.suma;
		END LOOP;
		
		val_entro := 0;
		
		IF cad ISNULL THEN
			txt := ''SELECT count AS con, ctid AS t FROM viewc1 WHERE ''||att||''!=''''-1'''''';
		ELSE
			txt := ''SELECT count AS con, ctid AS t FROM viewc1 WHERE ''||cad||'' AND ''||att||''!=''''-1'''''';
		END IF;
	
		FOR rec1 IN EXECUTE txt LOOP
			val_fraccion := CAST(rec1.con as numeric)/CAST(sum as numeric); 
			val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1;
			cad1 := rec1.t;
			EXECUTE ''UPDATE viewc1 SET entro=''||val_entro||'' WHERE ctid=''''''||cad1||'''''''';
		END LOOP;

		IF cad ISNULL THEN
			txt := ''SELECT ''||att||'' AS at,count,entro FROM viewc1 WHERE ''||att||''!=''''-1'''''';
		ELSE
			txt := ''SELECT ''||att||'' AS at,count,entro FROM viewc1 WHERE ''||cad||'' AND ''
						||att||''!=''''-1'''''';
		END IF;
		

		Gan := 0;
		cad :=NULL;
		sum1 := 0;
		Ent := 0;
		FOR rec1 IN EXECUTE txt LOOP			
	
			IF cad ISNULL THEN
				cad = CAST(rec1.at as bpchar);
				sum1 = rec1.count;
				Ent = rec1.entro;
				
			ELSE
				IF cad = rec1.at THEN
					sum1 := sum1 + rec1.count;
					Ent := Ent + rec1.entro;
					
				ELSE
					cad := rec1.at;
					Gan := Gan + ((CAST(sum1 as numeric)/CAST(sum as numeric))*CAST(Ent as numeric));
			
					sum1 := rec1.count;
					Ent := rec1.entro;
				END IF;
			END IF;	
		END LOOP;
		Gan := Gan + ((CAST(sum1 as numeric)/CAST(sum as numeric))*CAST(Ent as numeric));
	RETURN NEXT Gan;	
	
			
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);


