CREATE OR REPLACE FUNCTION mate_tree(integer,integer,integer,varchar) RETURNS SETOF integer AS' --i,cp,nodo,clase
DECLARE
	con 		integer;	
	numatt	integer;
	i		integer; -- contador tabla de nodos
	cp 		integer; -- contador pg_pila
	nnodos	integer := 0;
	BAN		integer;
	
	Gan		numeric;
	G_min		numeric :=0;
	
	sql		text DEFAULT NULL;	
	sql2		text DEFAULT '''';
	sql4		text DEFAULT '''';
	sql_g		text DEFAULT '''';
	clase		text DEFAULT '''';
	cad		text DEFAULT NULL;
	grp		text DEFAULT '''';
	att		text DEFAULT NULL;
	txt		text DEFAULT '''';
	txt1		text DEFAULT '''';
	rta		text DEFAULT '''';
	
	Ent		datentro%ROWTYPE;
	
	rec1		record;
	rec2		record;
	rec3		record;
	rec_g		record;
BEGIN
     
	clase := $4;	--**Atributo Clase
	i := $1;
	cp := $2;
	
	EXECUTE ''SELECT * FROM view_set(''''kdd_clase'''')'';	

--**VALIDAR QUE EL SUBGRUPO DE DATOS PERTENESCAN O NO A LA MISMA CLASE
			
		BAN = 0;
		sql := ''SELECT '' || clase || '' AS cl,count(*) AS ct FROM viewc1 GROUP BY '' || clase;
			
		con := 0;							
		FOR rec2 IN EXECUTE sql LOOP				
 			con := con + 1;
		END LOOP;	
			
		IF (con > 1) THEN 
			BAN = 1;-- indica que hay mas integer; de una clase
		END IF;
			
		IF (BAN = 1) THEN
		
			FOR rec2 IN EXECUTE ''SELECT relnatts FROM pg_class WHERE pg_class.relname = ''''kdd_ent'''''' LOOP
			END LOOP;
				
			IF (cp= rec2.relnatts) THEN
				BAN := 2;
			END IF;
		END IF;
			
		IF (BAN = 1) THEN		
				
			cad := NULL;	
			FOR rec2 IN EXECUTE ''SELECT att FROM pg_pila'' LOOP
				IF cad ISNULL THEN
					cad := ''attname!=''''''|| rec2.att ||'''''''';
					rta := rec2.att;
				ELSE
					cad := cad || '' AND attname!='''''';
					cad := cad || rec2.att ||'''''''';
					rta := rta || '','' || rec2.att;
				END IF;
			END LOOP;	
				
			sql := ''SELECT attname,attnum FROM pg_class,pg_attribute WHERE ''
			|| ''pg_class.relname=''''viewc1'''' AND pg_attribute.attrelid= pg_class.oid AND ''
			|| cad || '' AND attname!= ''''entro'''' AND attname!= ''''count'''' AND attnum > 0 ORDER BY attnum'';	

			G_min := 999;
			FOR rec2 IN EXECUTE sql LOOP			
		 		EXECUTE ''INSERT INTO pg_pila VALUES(''|| (cp+1) ||'',0,'''''' || rec2.attname || '''''',-1)'';
		
				sql2 := ''SELECT * FROM mate_gain(''||cp+1||'','''''' || clase || '''''')'';	
			
				FOR rec3 IN EXECUTE sql2 LOOP
				END LOOP;
				
				IF rec3.mate_gain < G_min THEN
					G_min := rec3.mate_gain;				
					txt := rec2.attname;
					numatt := rec2.attnum;
					rta := rec2.attname;					
				END IF;
				
				EXECUTE ''DELETE FROM pg_pila WHERE num='' || (cp+1);
			END LOOP;			
			
			
			EXECUTE ''UPDATE mate_nodes SET hijo=''||(i+1)||'' WHERE nodo=''||$3;

			sql := ''SELECT ''||txt||'' AS at FROM viewc1 WHERE ''||txt||''!=''''-1'''' GROUP BY ''||txt;

			FOR rec1 IN EXECUTE sql LOOP		
				i := i + 1;
				EXECUTE ''INSERT INTO mate_nodes VALUES(''||i||'',''||$3||'','''''' || txt || '''''',''||rec1.at||'',-1,''||(i+1)||'',-1)'';									
			END LOOP;		
			EXECUTE ''UPDATE mate_nodes SET herm = -1 WHERE nodo=''||i;	
		
		ELSE	
			
			IF con = 1 OR BAN = 2 THEN
				IF BAN = 0 THEN
					EXECUTE ''UPDATE mate_nodes SET clase=''|| CAST(rec2.cl as int2) ||'' WHERE nodo=''||$3;
					numatt := rec2.cl;
					
				ELSE
					EXECUTE ''UPDATE mate_nodes SET clase=-999 WHERE nodo=''||nnodos;
						numatt := -999;						
				END IF;	
	
--**AGREGAR REGLA A LA TABLA DE REGLAS

				FOR rec2 IN EXECUTE ''	SELECT MAX(id) AS cc FROM mate_rules'' LOOP
					con := rec2.cc + 1;
				END LOOP;
				IF con ISNULL THEN
					con :=1;
				END IF;
					
				sql := ''SELECT att,valor FROM pg_pila WHERE num!=0'';
				FOR rec2 IN EXECUTE sql LOOP
					rta := rec2.att;
					FOR rec3 IN EXECUTE ''SELECT attnum FROM pg_attribute WHERE attname=''''''||rta||'''''''' LOOP
					END LOOP;
						
					sql2 := ''INSERT INTO mate_rules VALUES(''||con||'',''||rec3.attnum||'',''||rec2.valor||'')'';
					EXECUTE sql2;
				END LOOP;

				FOR rec3 IN EXECUTE ''SELECT attnum FROM pg_attribute WHERE attname=''''''||clase||'''''''' LOOP
				END LOOP;				

				EXECUTE ''INSERT INTO mate_rules VALUES(''||con||'',''||rec3.attnum||'',''|| numatt||'')'';
			ELSE
				con := 0;
				FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE hijo=''||$3 LOOP
					FOR rec2 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo=''||$3 LOOP						
					END LOOP;
					EXECUTE ''UPDATE mate_nodes SET hijo = ''||rec2.herm || '' WHERE hijo=''||$3;
					con := 1;
				END LOOP;
				IF con = 0 THEN
					FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE herm=''||$3 LOOP
						FOR rec2 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo=''||$3 LOOP						
						END LOOP;
						EXECUTE ''UPDATE mate_nodes SET herm = ''||rec2.herm || '' WHERE hijo=''||$3;						
					END LOOP;
				END IF;
				EXECUTE ''DELETE FROM mate_nodes WHERE nodo=''||$3;

			END IF;
			BAN := 2;
		END IF;	
		EXECUTE ''DELETE FROM pg_pila WHERE num = ''||cp;
	RETURN NEXT BAN;
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

