CREATE OR REPLACE FUNCTION sliq(varchar) RETURNS SETOF varchar AS' --clase
DECLARE
		
	ban		integer;
	con		integer;
	nodo		integer;
	hijo		integer;
	cona		integer;
	cp		integer; -- contador pg_pila
	i		integer; -- contador sliq_nodes
		
	Gan		float;
	Gan_may		float;
	div		float;
	naux		float;
	nant		float;
		
	attgan		text DEFAULT NULL;
	attganv		text DEFAULT NULL;
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	sql2		text DEFAULT '''';
	atributos	text DEFAULT NULL;
	condicion	text DEFAULT NULL;
	prueba		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN
	
--**CREA TABLA DE REGLAS

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_rules'''''' LOOP
		EXECUTE ''DROP TABLE sliq_rules'';
	END LOOP;	
	EXECUTE ''CREATE TABLE sliq_rules (n int2,id int2,atributo bpchar,valor bpchar,com bpchar)'';	

--**CREA TABLA sliq_cond

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_cond'''''' LOOP
		EXECUTE ''DROP TABLE sliq_cond'';
	END LOOP;
	
	EXECUTE ''CREATE TABLE sliq_cond(att varchar,valor bpchar,tipo int2)'';

--**CREA TABLA AUXILIAR pg_pila

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_pila'''''' LOOP
		EXECUTE ''DROP TABLE pg_pila'';
	END LOOP;
	
	EXECUTE ''CREATE TABLE pg_pila(n int2, id int2,att varchar,valor bpchar,com bpchar)'';
	EXECUTE ''INSERT INTO pg_pila VALUES(0,-1,''''''||$1||'''''',-1,''''-1'''')'';
	cp := 0;

--**CREA TABLA DE NODOS
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_nodes'''''' LOOP
		EXECUTE ''DROP TABLE sliq_nodes'';	
	END LOOP;
	
	EXECUTE ''CREATE TABLE sliq_nodes (nodo int2,padre int2,atributo bpchar,valor bpchar,com bpchar,hijo int2,herm int2,clase bpchar)'';
	
	EXECUTE ''SELECT * FROM sliq_tree(0,''''''||$1||'''''')'';
	ban := 0;
	nodo := 1;
	hijo := 0;
	con := 0;
	WHILE(ban = 0) LOOP

		FOR rec1 IN EXECUTE ''SELECT COUNT(*) AS id FROM pg_pila'' LOOP
			cp := rec1.id - 1;	
		END LOOP;
		FOR rec1 IN EXECUTE ''SELECT * FROM sliq_nodes WHERE nodo = ''|| nodo LOOP

			IF rec1.clase = -1 THEN
				cp := cp + 1;
				prueba := ''INSERT INTO pg_pila VALUES('' || cp || '','' || nodo || '','''''' || rec1.atributo || '''''','''''' || rec1.valor || '''''','''''' || rec1.com || '''''')'';
				EXECUTE prueba;
				hijo := rec1.hijo;	
				
			ELSE
				hijo := rec1.herm;	
			END IF;

		END LOOP;

		WHILE (hijo != -1)  LOOP
			nodo := hijo;	

			FOR rec1 IN EXECUTE ''SELECT * FROM sliq_nodes WHERE nodo = ''|| nodo LOOP

				IF rec1.clase = -1 THEN
					cp := cp + 1;
					prueba := ''INSERT INTO pg_pila VALUES(''||cp||'',''||nodo||'',''''''||rec1.atributo||'''''','''''' ||rec1.valor||'''''',''''''||rec1.com||'''''')'';
					EXECUTE prueba;
					hijo := rec1.hijo;					
				ELSE
					
					hijo := rec1.herm;
	
					IF con = nodo THEN
						ban := 1;
							hijo := 0;
					END IF;	
				END IF;
			END LOOP;			
		END LOOP;

		IF rec1.clase = ''-1'' AND rec1.nodo != 0 THEN
				EXECUTE ''SELECT * FROM sliq_tree(''||nodo||'',''''''||$1||'''''')'';
			FOR rec2 IN EXECUTE ''SELECT MAX(nodo) AS nd FROM sliq_nodes'' LOOP
				con := rec2.nd;
			END LOOP;			
		END IF;

		IF (rec1.herm != -1) THEN
			nodo := rec1.herm;			
		ELSE 
			nodo := rec1.padre;	
	
			IF nodo ISNULL THEN
				ban := 1;
			ELSE	
				FOR rec1 IN EXECUTE ''SELECT * FROM sliq_nodes WHERE nodo = ''|| nodo LOOP
					nodo := rec1.herm;

				END LOOP;
			END IF;
		END IF;
		IF cp > 0 THEN
			FOR rec2 IN EXECUTE ''SELECT * FROM pg_pila WHERE n=''||cp LOOP
				EXECUTE ''DELETE FROM pg_pila WHERE id = ''||rec2.id;			
			END LOOP;
		END IF;
		IF nodo = -1 THEN
			nodo := 1;
		END IF;				

	END LOOP;

	
	EXECUTE ''DROP TABLE pg_pila'';
	EXECUTE ''DROP TABLE sliq_cond'';
	EXECUTE ''DROP TABLE viewc1'';
	
	RETURN NEXT ''CREADA TABLA sliq_rules'';
	RETURN NEXT ''CREADA TABLA sliq_nodes'';
	
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
