CREATE OR REPLACE FUNCTION sliq_combinar(INTEGER) RETURNS SETOF varchar AS ' 
DECLARE
	sql		text DEFAULT '''';	
	sql1		text DEFAULT '''';	
	cad		text DEFAULT NULL;	
	cada		text DEFAULT '''';
	cade		text DEFAULT '''';
	
	rec1		record;	
	rec2		record;	
	rec3		record;	
	
	flag_val	integer;	
	localset	integer;
	attr		integer;
	active		integer;
	control1	integer;
	control2	integer;
	control3	integer;
	flag		integer;
	i		integer;
	num		integer;
	machete		integer;
	
BEGIN	

--**CREA TABLA DE COMBINACIONES

	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_columna'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_columna'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_columna(num int2,att bpchar)'';		

	
	sql1 := ''SELECT attname,relnatts FROM pg_class, pg_attribute'';
	sql1 := sql1 || '' WHERE pg_class.relname = ''''sliq_val'''''';
	sql1 := sql1 || '' AND pg_attribute.attrelid = pg_class.oid'';
	sql1 := sql1 || '' AND attnum > 0 ORDER BY attnum'';
	
	i := 1;
	
	FOR rec1 IN EXECUTE sql1 LOOP	
		IF cad ISNULL THEN
			cad := rec1.attname ||'' bpchar'';
			cada := rec1.attname;
			cade := ''''''''||rec1.attname||'''''''';
			
			EXECUTE ''INSERT INTO pg_columna VALUES(''||i||'',''''''||rec1.attname||'''''')'';	

		ELSE
			cad := cad ||'',''|| rec1.attname || '' bpchar'';
			cada := cada ||'',''||rec1.attname;
			cade := cade ||'',''''''||rec1.attname||'''''''';
			EXECUTE ''INSERT INTO pg_columna VALUES(''||i||'',''''''||rec1.attname||'''''')'';	

		END IF;
		attr := rec1.relnatts;
		i := i + 1;
	END LOOP;	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''sliq_cmb'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE sliq_cmb'';	
	END IF;	
	EXECUTE''CREATE TABLE sliq_cmb('' || cad || '')'';	
	IF $1 = 1 THEN
		EXECUTE ''INSERT INTO sliq_cmb VALUES(''||cade||'')'';
	END IF;
	
	
--**CREA TABLA DE POSICIONES
	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_pos'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_pos'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_pos(n int2,pos int2)'';

--**CREA TABLA DE ATRIBUTOS AUXILIAR cadena
	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_att'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_att'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_att(att bpchar)'';

--**COMBINACIONES
	
	localset := 0;
	
	WHILE localset <= attr LOOP --WHILE1
		
		active := 0;
		
		EXECUTE ''SELECT * FROM controlposicion(0,''||localset||'',0)'';
		
		active := localset - 1;
		
		FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=0'' LOOP
			control1 := rec2.pos; --controlPosicion[0]
		END LOOP;
		
		machete := 0;
		
		WHILE (control1 < attr - (localset-1)) LOOP --WHILE2
		
		--machete := machete + 1;
		
			FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP
				control2 := rec2.pos; --controlPosicion[active]
			END LOOP;	
			
			WHILE (control2 < attr) LOOP --WHILE3
			
				flag := 1;
				
				i := 0;
				
				WHILE (i < localset AND flag = 1) LOOP	--WHILE 4
				
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||i LOOP
					END LOOP;
					num := rec2.pos;
					
					FOR rec2 IN EXECUTE ''SELECT att FROM pg_columna WHERE num=''||(num+1) LOOP
					END LOOP;
					
					sql := ''INSERT INTO pg_att VALUES(''''''||rec2.att||'''''')'';	
					
					IF rec2.att IS NULL THEN
						flag := 0;
					ELSE
						EXECUTE sql;	
					END IF;
					
					i := i + 1;	
				END LOOP;
					
				IF flag = 1 THEN
				
					sql := NULL;
					sql1 := NULL;
					
					FOR rec2 IN EXECUTE ''SELECT att FROM pg_att'' LOOP
					
						IF sql IS NULL THEN
							sql := ''INSERT INTO sliq_cmb('' || rec2.att;
							sql1 := '' SELECT ''||rec2.att;
						ELSE
							sql := sql ||'','' || rec2.att;
							sql1 := sql1 ||'',''||rec2.att;
						END IF;	
						
					END LOOP;
					
					sql := sql || '')'';
					sql1 := sql1 || '' FROM sliq_val'';
					
					sql := sql || sql1;
					
					EXECUTE sql;	
					
					EXECUTE ''DELETE FROM pg_att'';
					
					
				END IF;
				
				control2 := control2 + 1;
				EXECUTE ''UPDATE pg_pos SET pos = ''||control2||'' WHERE n=''||active;
				
			END LOOP; --WHILE 3
			
			IF active > 0 THEN
				
				control2 := control2 - 1;
				EXECUTE ''UPDATE pg_pos SET pos = ''||control2||'' WHERE n=''||active;
				
				FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||(active-1) LOOP				
				END LOOP;
				control3 := rec2.pos + 1;	
				
				WHILE (active > 0 AND ((control3 + 1)>control2)) LOOP
					
					active := active - 1;
					
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP					
					END LOOP;
					control2 := rec2.pos;
					
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||(active-1) LOOP					
					END LOOP;
					control3 := rec2.pos + 1;
					
				END LOOP;
				
				IF active > 0 THEN
					active := active - 1;
				END IF;
				
				--clami
				FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP
				END LOOP;
				control2 := rec2.pos + 1;
				
				EXECUTE ''SELECT * FROM controlposicion(''||control2||'',''||localset||'',''||active||'')'';
				
				active := localset - 1;
				
			END IF;
			
			FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=0'' LOOP
			END LOOP;
			control1 := rec2.pos;	
			
		END LOOP; --WHILE2
	
		localset := localset + 1;
		
	END LOOP;--WHILE1	
	cad := NULL;
	FOR rec1 IN EXECUTE ''SELECT ctid AS m FROM sliq_cmb'' LOOP
		cad := rec1.m;
	END LOOP;
	
	EXECUTE ''DELETE FROM sliq_cmb WHERE ctid=''''''||cad||'''''''';
	
	EXECUTE ''DROP TABLE pg_columna'';
	EXECUTE ''DROP TABLE pg_pos'';
	EXECUTE ''DROP TABLE pg_att'';	
	EXECUTE ''DROP TABLE sliq_val'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);