CREATE OR REPLACE FUNCTION process_fcd(varchar,varchar) RETURNS SETOF varchar AS '
/* Esta funcion crea una nueva tabla con los registros que cumplan determinada condicion, los parametros que  * recibe son el nombre de la tabla y la condicion.
*/
DECLARE
	
	i		integer;
	cont		integer;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	tabla		varchar DEFAULT NULL;
		
	rec1		record;	
	oid		integer;
	
	flag_val	text;
	
BEGIN

--****	CREA TABLA tablaF

	tabla = $1 ||''f'';
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT COUNT(*) AS cc FROM ''||$1||'' WHERE ''||$2 LOOP
		IF rec1.cc > 0 THEN
			EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM ''||$1||'' WHERE ''||$2;	
			RETURN NEXT tabla;	
		END IF;
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''fl_''||$1||'''''''' LOOP	
			EXECUTE ''DROP TABLE fl_''||$1;	
	END LOOP;
	EXECUTE ''CREATE TABLE fl_''||$1||'' AS SELECT * FROM ''||tabla;
	EXECUTE ''DROP TABLE ''||tabla;	
	
	RETURN NEXT ''fl_''||$1;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);