CREATE OR REPLACE FUNCTION process_rdm(varchar,integer) RETURNS SETOF varchar AS '
DECLARE
	
	i		integer;
	cont		integer;
	rm		numeric;
	ban		integer = 0;
	
	tabla		varchar DEFAULT NULL;
	sql		varchar DEFAULT NULL;
	cad		varchar DEFAULT NULL;
		
	rec1		record;		
	rec2		record;		
	
BEGIN
 	IF $1 = ''kdd_ent'' THEN
 		tabla := ''kdd_pru'';
 	ELSE
		tabla := ''pg_col'';
 		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''kdd_ent'''''' LOOP	
 			EXECUTE ''DROP TABLE kdd_ent'';		
 		END LOOP;

		EXECUTE ''CREATE TABLE kdd_ent AS SELECT * FROM ''||$1;
 	END IF;

RAISE NOTICE ''ACA 2'';
	cont := $2;	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	i :=0;
	WHILE i < cont LOOP
		FOR rec1 IN EXECUTE ''SELECT ctid FROM kdd_ent'' LOOP
			cad := rec1.ctid;
			FOR rec2 IN EXECUTE ''SELECT * FROM random()'' LOOP				
				rm := rec2.random;
			END LOOP;			
			IF i< cont THEN
				IF rm < 0.5 THEN
					IF i = 0 THEN
						EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM kdd_ent WHERE ctid=''''''||cad||'''''''';
					ELSE
						EXECUTE ''INSERT INTO ''||tabla||'' SELECT * FROM kdd_ent WHERE ctid=''''''||cad||'''''''';
					END IF;
					i := i + 1;				
					EXECUTE ''DELETE FROM kdd_ent WHERE ctid=''''''||cad||'''''''';		
				END IF;
			END IF;
		END LOOP;				
	END LOOP;

	IF $1 <> ''kdd_ent'' THEN
		sql := ''SELECT attname,typname FROM pg_class, pg_attribute,pg_type''
			|| '' WHERE pg_class.relname = ''''''||$1||''''''''
			|| '' AND pg_type.oid = atttypid AND pg_attribute.attrelid = pg_class.oid AND attnum>0 ORDER BY attnum'';
		cad := NULL;
		FOR rec1 IN EXECUTE sql LOOP
			IF cad ISNULL THEN
				cad := rec1.attname||'' ''||rec1.typname;
			ELSE
				cad := cad ||'',''||rec1.attname||'' ''||rec1.typname;
			END IF;
		END LOOP;	
		tabla := ''fl_''||$1;		
		EXECUTE ''COPY pg_col TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
		EXECUTE ''DROP TABLE pg_col'';
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
			EXECUTE ''DROP TABLE ''||tabla;	
		END LOOP;
		EXECUTE ''CREATE TABLE ''||tabla||'' (''||cad||'')''; 
		EXECUTE ''COPY ''||tabla||'' FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
		EXECUTE ''DROP TABLE kdd_ent'';
	END IF;	
	
	RETURN NEXT tabla;	
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);