/*
 * Matetree.java
 *
 * Created on 2 de agosto de 2016, 9:50
 */

package Iprincipal;

/**
 *
 * @author  ivan
 */
import AsistenteConexion.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File.*;
import java.io.File;
import java.lang.Integer;
import java.sql.*;
import java.util.*;
import java.util.Date;
import javax.swing.*;
import java.lang.String.*;
import paquetes.*;



public class Matetree extends javax.swing.JPanel {
     JPopupMenu popup = new JPopupMenu();    
    public static Vector mod = new Vector();
    public static String ren;
    public static Vector modelos = new Vector();
    private JFileChooser fc = new JFileChooser();
    public static int Rpru;
    public double tiempo;
    public static int ccm;
    public static String n = "0";
    public static ThreadCarga1 hilo = null;
    public static int ba = 0; 
    public static Object objeto = new Object();
    public static boolean pideparar = false;
     
    public Matetree() {
        initComponents();                    
        this.setSize(675, 430);      
        barra.setVisible(false);
        String arc; 
        File dr = new File("/opt/Matekdd/models/");
        fc.setCurrentDirectory(dr);
        ActionListener  al = new ActionListener(){
            public void actionPerformed( ActionEvent evt){
                        String cadena = new String(((JMenuItem)evt.getSource()).getText());
                        ExampleFileFilter ext = new ExampleFileFilter(".mtr", "Modelos de Matekdd");
                        String archivo;                
                        if(cadena.compareTo("Guardar Modelo") == 0){                            
                            fc.setDialogTitle("Guardar Modelo");
                            fc.setApproveButtonText("Save");                    
                            int returnVal = fc.showOpenDialog(Matetree.this);
                            if (returnVal == JFileChooser.APPROVE_OPTION) {
                                File f = fc.getSelectedFile();
                                String dir = new String(fc.getCurrentDirectory().toString());                        
                                String arc = new String(fc.getName(f));                                  
                                String res = Mfiles.GuardarMod(dir,arc+".mtr",2);                        
                                if (res.length()<=0){
                                    JOptionPane.showMessageDialog(Matetree.this,"Error: al Guardar !","MATE-TREE",JOptionPane.ERROR_MESSAGE);
                                }else{
                                    int id = lst_1.getSelectedIndex();
                                    String sql = new String("CREATE TABLE "+arc+" AS SELECT * FROM "+lst_1.getSelectedValue().toString());                                    
                                    //System.out.println(sql);
                                    Matekdd.CC.Ejecutar(sql,2);
                                    sql = "SELECT * FROM save_tree('"+lst_1.getSelectedValue().toString()+"','"+arc+"',1,'"+dir+"',1)";
                                   // System.out.println(sql);
                                    Matekdd.CC.Ejecutar(sql,2);
                                    Matekdd.CC.Ejecutar("DROP TABLE "+lst_1.getSelectedValue().toString(),2);
                                    mod.remove(id);
                                    ren = modelos.elementAt(id).toString();                            
                                    modelos.remove(id);
                                    modelos.add(ren);
                                    mod.addElement(arc);
                                    lst_1.setListData(mod);
                                    JOptionPane.showMessageDialog(Matetree.this,"Modelo Guardado !","MATE-TREE",JOptionPane.INFORMATION_MESSAGE);
                                }
                            } 
                        }
                    else if(cadena.compareTo("Abrir Modelo") == 0){
                            fc.setDialogTitle("Abrir Modelo");                    
                            int returnVal = fc.showOpenDialog(Matetree.this);
                            if (returnVal == JFileChooser.APPROVE_OPTION) {
                                File f = fc.getSelectedFile();
                                String dir = fc.getCurrentDirectory().toString();                        
                                String arc = fc.getName(f);                                
                                if (Mfiles.AbrirMod(dir,arc+".mtr",2).length()<=0){
                                    JOptionPane.showMessageDialog(Matetree.this,"Error: al Abrir !","MATE-TREE",JOptionPane.ERROR_MESSAGE);
                                }else{
                                    mod.addElement(arc);
                                    lst_1.setListData(mod);
                                    Matekdd.CC.Ejecutar("SELECT * FROM save_tree('"+arc+"','"+arc+"',2,'"+dir+"',1)",2);
                                }                        
                            }
                    }
                   else if(cadena.compareTo("Ver Arbol") == 0){
                        new viewtree(lst_1.getSelectedValue().toString(),2,lbl_02.getText(), "Mate-Tree");
                    }
                }
        };   
        
        
        JMenuItem elemento = new JMenuItem("Abrir Modelo");
        elemento.addActionListener( al );
        popup.add(elemento);
        elemento = new JMenuItem("Guardar Modelo");
        elemento.addActionListener( al );
        popup.add(elemento);
        elemento = new JMenuItem("Ver Arbol");
        elemento.addActionListener( al );
        popup.add(elemento);       
    }

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        Popc1 = new javax.swing.JPanel();
        rbtn_1 = new javax.swing.JRadioButton();
        rbtn_2 = new javax.swing.JRadioButton();
        rbtn_3 = new javax.swing.JRadioButton();
        txt_1 = new javax.swing.JTextField();
        txt_2 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        Pmod1 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        lst_1 = new javax.swing.JList();
        Pred1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txta = new javax.swing.JTextArea();
        jPanel3 = new javax.swing.JPanel();
        lbl_02 = new javax.swing.JLabel();
        btn_1 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        lbl_est = new javax.swing.JLabel();
        barra = new javax.swing.JProgressBar();
        jPanel5 = new javax.swing.JPanel();
        lbl_3 = new javax.swing.JLabel();
        txthost = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();

        setLayout(null);

        setPreferredSize(new java.awt.Dimension(900, 650));
        Popc1.setLayout(null);

        Popc1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Opciones de Prueba ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        Popc1.setFont(new java.awt.Font("Dialog", 1, 12));
        buttonGroup1.add(rbtn_1);
        rbtn_1.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_1.setSelected(true);
        rbtn_1.setText("Usar Conjunto de Entrenamiento");
        rbtn_1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_1.setName("rbtn_1");
        rbtn_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_1ActionPerformed(evt);
            }
        });

        Popc1.add(rbtn_1);
        rbtn_1.setBounds(10, 30, 240, 15);

        buttonGroup1.add(rbtn_2);
        rbtn_2.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_2.setText("Usar Division de");
        rbtn_2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_2.setName("rbtn_2");
        rbtn_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_2ActionPerformed(evt);
            }
        });

        Popc1.add(rbtn_2);
        rbtn_2.setBounds(10, 60, 140, 20);

        buttonGroup1.add(rbtn_3);
        rbtn_3.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_3.setText("Usar");
        rbtn_3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_3.setName("rbtn_3");
        rbtn_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_3ActionPerformed(evt);
            }
        });

        Popc1.add(rbtn_3);
        rbtn_3.setBounds(10, 100, 50, 15);

        txt_1.setEditable(false);
        txt_1.setText("20");
        txt_1.setName("txt_1");
        Popc1.add(txt_1);
        txt_1.setBounds(150, 60, 50, 20);

        txt_2.setEditable(false);
        txt_2.setName("txt_2");
        Popc1.add(txt_2);
        txt_2.setBounds(70, 100, 50, 20);

        jLabel3.setText("%");
        Popc1.add(jLabel3);
        jLabel3.setBounds(210, 60, 20, 20);

        jLabel2.setForeground(new java.awt.Color(102, 102, 102));
        jLabel2.setText("Instancias");
        Popc1.add(jLabel2);
        jLabel2.setBounds(140, 100, 100, 20);

        add(Popc1);
        Popc1.setBounds(10, 190, 260, 140);

        Pmod1.setLayout(null);

        Pmod1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lista de Modelos ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        Pmod1.setFont(new java.awt.Font("Dialog", 1, 12));
        lst_1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lst_1evtpopup(evt);
            }
        });

        jScrollPane3.setViewportView(lst_1);

        Pmod1.add(jScrollPane3);
        jScrollPane3.setBounds(10, 30, 240, 160);

        add(Pmod1);
        Pmod1.setBounds(10, 340, 260, 200);

        Pred1.setLayout(null);

        Pred1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Informacion del Modelo ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        Pred1.setFont(new java.awt.Font("Dialog", 1, 12));
        txta.setColumns(20);
        txta.setFont(new java.awt.Font("Monospaced", 1, 12));
        txta.setRows(5);
        jScrollPane1.setViewportView(txta);

        Pred1.add(jScrollPane1);
        jScrollPane1.setBounds(20, 30, 580, 480);

        add(Pred1);
        Pred1.setBounds(270, 10, 620, 530);

        jPanel3.setLayout(null);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Atributo Clase ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel3.setFont(new java.awt.Font("Dialog", 1, 12));
        lbl_02.setFont(new java.awt.Font("Dialog", 1, 14));
        lbl_02.setForeground(new java.awt.Color(102, 102, 102));
        lbl_02.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lbl_02.setText("A");
        jPanel3.add(lbl_02);
        lbl_02.setBounds(10, 20, 240, 20);

        add(jPanel3);
        jPanel3.setBounds(10, 70, 260, 50);

        btn_1.setFont(new java.awt.Font("Bitstream Vera Sans", 1, 18));
        btn_1.setForeground(new java.awt.Color(102, 102, 102));
        btn_1.setText("Clasificar");
        btn_1.setToolTipText("Crear Modelo de Clasificaci\u00f3n");
        btn_1.setEnabled(false);
        btn_1.setRolloverEnabled(false);
        btn_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_1clasificador(evt);
            }
        });

        add(btn_1);
        btn_1.setBounds(690, 550, 200, 35);

        jPanel4.setLayout(null);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Estado ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel4.setFont(new java.awt.Font("Dialog", 1, 12));
        lbl_est.setForeground(new java.awt.Color(102, 102, 102));
        lbl_est.setText("OK");
        jPanel4.add(lbl_est);
        lbl_est.setBounds(10, 20, 480, 20);

        barra.setForeground(new java.awt.Color(204, 204, 204));
        jPanel4.add(barra);
        barra.setBounds(10, 20, 640, 20);

        add(jPanel4);
        jPanel4.setBounds(10, 540, 670, 50);

        jPanel5.setLayout(null);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Prepoda", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel5.setFont(new java.awt.Font("Dialog", 1, 12));
        lbl_3.setFont(new java.awt.Font("Dialog", 1, 14));
        lbl_3.setForeground(new java.awt.Color(102, 102, 102));
        lbl_3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lbl_3.setText("Confianza");
        jPanel5.add(lbl_3);
        lbl_3.setBounds(20, 20, 120, 20);

        txthost.setText("1");
        jPanel5.add(txthost);
        txthost.setBounds(130, 20, 50, 22);

        add(jPanel5);
        jPanel5.setBounds(10, 130, 260, 50);

        jPanel6.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "  ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel6.setFont(new java.awt.Font("Dialog", 1, 12));
        jLabel4.setFont(new java.awt.Font("Bitstream Vera Serif", 1, 24));
        jLabel4.setForeground(new java.awt.Color(102, 102, 102));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("MATE-TREE");
        jPanel6.add(jLabel4);
        jLabel4.setBounds(40, 10, 170, 30);

        add(jPanel6);
        jPanel6.setBounds(10, 10, 260, 50);

    }// </editor-fold>//GEN-END:initComponents
public void iniciacuenta(){
        if( Matetree.hilo == null){
            Matetree.barra.setVisible(true);
            Matetree.hilo = new ThreadCarga1();
            Matetree.pideparar = false;
            Matetree.hilo.start();
        }
    }
    private void btn_1clasificador(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_1clasificador
        int n = Matekdd.CC.getcolumncount(Preprocesamiento.lbl_tabla.getText());
         
         
            Thread Mate = new Thread(new Algoritmo_Matetree(),"hilo a");  
                Mate.start();
                iniciacuenta();
            if(ba==1){
                     JOptionPane.showMessageDialog(this,"El Algoritmo No Procesa Atributos Numericos!!"+'\n'+"Debe Discretizar en la Etapa de Preprocesamiento","MATETREE",JOptionPane.ERROR_MESSAGE);

            }else if(ba==2){
                 JOptionPane.showMessageDialog(this,"ERROR: No Hay Conexion!!","MATETREE",JOptionPane.ERROR_MESSAGE);
            }else if (ba==3){
                     JOptionPane.showMessageDialog(this,"ERROR: En Proceso de Clasificacion!!!!","MATETREE",JOptionPane.ERROR_MESSAGE);
          
          
          
        
         }
        
    }//GEN-LAST:event_btn_1clasificador

       
    private void lst_1evtpopup(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lst_1evtpopup
        int id;
        Vector aux = new Vector();
        if (!evt.isPopupTrigger() && SwingUtilities.isRightMouseButton(evt)){
            popup.show(evt.getComponent(),evt.getX(),evt.getY());
        } else{
            ren = null;
            super.processMouseEvent(evt);
            id = lst_1.getSelectedIndex();
            txta.setText(modelos.get(id).toString());
            
        }
    }//GEN-LAST:event_lst_1evtpopup

    private void rbtn_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_3ActionPerformed
        txt_1.setEditable(false);
        txt_2.setEditable(true);
    }//GEN-LAST:event_rbtn_3ActionPerformed

    private void rbtn_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_2ActionPerformed
        txt_1.setEditable(true);
        txt_2.setEditable(false);
    }//GEN-LAST:event_rbtn_2ActionPerformed

    private void rbtn_1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_1ActionPerformed
        txt_1.setEditable(false);
        txt_2.setEditable(false);
    }//GEN-LAST:event_rbtn_1ActionPerformed
    
     
     
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public static javax.swing.JPanel Pmod1;
    public static javax.swing.JPanel Popc1;
    public static javax.swing.JPanel Pred1;
    public static javax.swing.JProgressBar barra;
    public static javax.swing.JButton btn_1;
    public static javax.swing.ButtonGroup buttonGroup1;
    public static javax.swing.JLabel jLabel2;
    public static javax.swing.JLabel jLabel3;
    public static javax.swing.JLabel jLabel4;
    public static javax.swing.JPanel jPanel3;
    public static javax.swing.JPanel jPanel4;
    public static javax.swing.JPanel jPanel5;
    public static javax.swing.JPanel jPanel6;
    public static javax.swing.JScrollPane jScrollPane1;
    public static javax.swing.JScrollPane jScrollPane3;
    public static javax.swing.JLabel lbl_02;
    public static javax.swing.JLabel lbl_3;
    public static javax.swing.JLabel lbl_est;
    public static javax.swing.JList lst_1;
    public static javax.swing.JRadioButton rbtn_1;
    public static javax.swing.JRadioButton rbtn_2;
    public static javax.swing.JRadioButton rbtn_3;
    public static javax.swing.JTextField txt_1;
    public static javax.swing.JTextField txt_2;
    public static javax.swing.JTextArea txta;
    public static javax.swing.JTextField txthost;
    // End of variables declaration//GEN-END:variables
    
}

//CLASE DEL ALGORITMO
   class Algoritmo_Matetree extends Thread{
    private double tiempo;
    /** Creates a new instance of Algoritmo_Matetree */
    public Algoritmo_Matetree() {
        
    } 
     
    private void preproceso(){
         int numR = 0;
         String sql;
         Double x;
         
                if(Matetree.rbtn_2.isSelected()){
            float por ;
            if( Integer.parseInt(Matetree.txt_1.getText())<101 && Integer.parseInt(Matetree.txt_1.getText())>0){
                numR = Integer.parseInt(Seleccion.lbl_ins.getText());
                por = new Float(Matetree.txt_1.getText()) / 100;
                numR = (int)(numR * por);                         
            }
         }else if(Matetree.rbtn_3.isSelected()){
            if(Integer.parseInt(Matetree.txt_2.getText())>0){
                numR = Integer.parseInt(Matetree.txt_2.getText());                
            }
         }
         else{
            numR = Integer.parseInt(Seleccion.lbl_ins.getText());
         }
         try{
                Matetree.Rpru = numR;
                if (numR == Integer.parseInt(Seleccion.lbl_ins.getText())){
                    numR = 0;
                }
                sql = "SELECT * FROM trans_c45_mate('"+Preprocesamiento.lbl_tabla.getText()+"','"+Matetree.lbl_02.getText()+"',"+numR+")";
                Matetree.lbl_est.setText(sql);
                sql = Matekdd.CC.Ejecutar(sql,2);                  
         }catch(Exception e){
          Matetree.ba=3;
          //JOptionPane.showMessageDialog(this,e.toString(),"MATE-TREE",JOptionPane.ERROR_MESSAGE);
          Algoritmo_Matetree.detienecuenta();
        }
             
         
    }
    
private void addarbol(){
	String sql;	
	String cad;        
        String nodo;        
        int tab = 0;
        String padre ="";
	System.out.println("Add arbol");
        try{
             nodo = "1";             
             cad = "\n|\t";
             ResultSet rs = null;
             do{
                 do{
                     sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase FROM mate_nodes where nodo=" + nodo;
                     rs = Matekdd.CC.stm.executeQuery(sql);
                     while(rs.next()){
                        nodo = rs.getString(5).toString();
                        padre = rs.getString(2).toString();
                        if(rs.getString(2).equals("0")==true){
                            cad = "\n";
                            tab = 1;
                            Matetree.ren += cad+"|-"+(rs.getString(3)) +" = "+ (rs.getString(4))+"    ";                            
                            if(rs.getString(7).equals("-1")==false){
                                cad = cad + "|\t|- ";
                                cad += Matetree.lbl_02.getText() +" = "+ (rs.getString(7))+"    ";
                                Matetree.ren += cad;
                            }
                	}else{
                                tab++;
                                cad = "\n|";
                                for(int i=2; i<=tab; i++){
                                    cad += "\t|";
                                }                                
                                Matetree.ren += cad+" -"+(rs.getString(3)) +" = "+ (rs.getString(4))+"    ";                            
                                if(rs.getString(7).equals("-1")==false){
                                    cad = cad + "|\t|- ";
                                    cad += Matetree.lbl_02.getText() +" = "+ (rs.getString(7))+"    ";
                                    Matetree.ren += cad;
                                }
                        }
                        if(nodo.equals("-1")==true){
                            nodo = rs.getString(6).toString();
                            tab--;
                        }
                        
                        if(nodo.equals("-1")==false){
                            sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase FROM mate_nodes where nodo=" + nodo;
                            rs = Matekdd.CC.stm.executeQuery(sql);
                        }                            
                     }     
                 //    System.out.println("El nodo del ciclo= "+nodo);
                 }while(nodo.equals("-1")==false);
                // System.out.println("Em pieza el otro ciclo"+nodo);
                 while(nodo.equals("-1")==true){                        
                     nodo = padre;                   
                     tab--;
                     if (nodo.equals("0")==false){
                        sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase FROM mate_nodes where nodo=" + nodo;
                        rs = Matekdd.CC.stm.executeQuery(sql);
                        while(rs.next()){
                         nodo = rs.getString(6).toString();
                         padre = rs.getString(2).toString();
                        }
                     }                     
                 }
               //  System.out.println("El nodo = "+nodo);
             }while(nodo.equals("0")==false && nodo.equals("-1")==false);       
            rs.close();	
        }catch(Exception e){
          // mate.ren += "\n NO SE PUDO MOSTRAR EL ARBOL!!";
            detienecuenta();
        }
      
    }
    
    private void validar(String modelo){
        String con;
	double por;
        try{
            String sql;	
			//DESCRIBIR EL ARBOL EN TEXTO	    
	    sql = "SELECT * FROM test_rules('"+modelo+"')";            
            con = Matekdd.CC.Ejecutar(sql,1);//aqui devuelve el nuemro de reg bien clasificados
            sql = "SELECT * FROM translate_rules('"+modelo+"')";
            sql = Matekdd.CC.Ejecutar(sql,2);          
            addarbol();
            Matetree.ren += "\n\n\n\t === .:. RESULTADOS DE LA PRUEBA .:. ===\n\n";
            sql = "SELECT * FROM arm_rules('"+Matetree.lbl_02.getText()+"','mate')";
            ResultSet rs = Matekdd.CC.stm.executeQuery(sql);
            while(rs.next()){
                Matetree.ren += "\n";
                Matetree.ren += (rs.getString(1)) + "    ";
            }
            rs.close();
            Matetree.ren += "\n\n";
            Matetree.ren += "- CONJUNTO DE PRUEBA: "+ Matetree.Rpru;
            int c = new Integer(con);
       //System.out.println(con);
		
            Matetree.ren +="\n\n- INSTANCIAS CORRECTAMENTE CLASIFICADAS: "+con+"     "+(c *100/ Matetree.Rpru)+" %" ;

		Matetree.ren +="\n\n- INSTANCIAS INCORRECTAMENTE CLASIFICADAS: "+(Matetree.Rpru-c)+"     "+((Matetree.Rpru-c)*100/Matetree.Rpru)+" %";

        }catch(Exception e){
           // JOptionPane.showMessageDialog(this,"Error en la Validacion"+'\n'+e.toString(),"MATE-TREE",JOptionPane.ERROR_MESSAGE);
            Matetree.ba=3;
           // Matetree.lbl_est.setText("Error en la Validacion");
            Algoritmo_Matetree.detienecuenta();
            System.out.println("En validacion"+e.toString());
        }
    }
    
    private void iniciarren(){
        int n = new Integer(Seleccion.lbl_ins.getText());
        n = n - Matetree.Rpru;        
        Matetree.ren += "\n\t ===  .:. MODELO DE CLASIFICACION DEL ALGORITMO MATE-TREE .:.   ===";        
        Matetree.ren += "\n\n";
        Matetree.ren += "- TABLA: "+Preprocesamiento.lbl_tabla.getText();
        Matetree.ren += "\n\n";
        Matetree.ren += "- INSTANCIAS: "+Preprocesamiento.lbl_ins.getText();
        Matetree.ren += "\n\n";
        Matetree.ren += "- ATRIBUTOS: "+Preprocesamiento.lbl_att.getText();
        Matetree.ren += "\n";
        Vector atts = new Vector();
        atts = Matekdd.CC.getcolumnname(Seleccion.lbl_tabla.getText());
        for(int i=0;i<atts.size();i++){
              Matetree.ren += "\n        "+(i+1)+"\t"+atts.elementAt(i);
        }
        Matetree.ren += "\n\n- CONJUNTO DE ENTRENAMIENTO: " + n;


        Matetree.ren += "\n\n\n\t ===  .:. ARBOL DE DECISION .:. ===";
        Matetree.ren += "\n";
    }

     
          
         public void run() {
             if(Matekdd.CC.db!=null){       
    
             Matetree.ba = 0;
             Vector atts = new Vector();
            atts = Matekdd.CC.getcolumnname(Preprocesamiento.lbl_tabla.getText());
            for(int i=0;i<atts.size();i++){
                     
                String att2 = new String(atts.elementAt(i).toString());
                String t2 = new String(Matekdd.CC.getTipo(Preprocesamiento.lbl_tabla.getText(),att2));            
             //  System.out.println("Atributo "+att2+" tipo "+t2);
                 if ("varchar".equals(t2)==false && "bpchar".equals(t2)==false){
                     
                     Matetree.ba = 1;
                     i = atts.size();
                 }
            }
            if(Matetree.ba == 0){    
                Matekdd.CC.cerrarBD();            
                Matekdd.CC.iniciarBD(frm_bd.txt_1.getText(),frm_bd.txt_2.getText(),new String(frm_bd.txt_3.getPassword()),frm_bd.txthost.getText(),frm_bd.spnPuerto.getValue().toString());
                Matetree.ren = new String();
                
        String sql="";
        iniciarren();
        Sliq.lbl_est.setText("Clasificando con Mate-Tree");
        try{  
            Matetree.lbl_est.setText("MODELANDO CON MATE-TREE");
            Matetree.ccm ++; 
            double tmp = System.currentTimeMillis();            
            preproceso();
            sql = "SELECT * FROM mateby('"+Matetree.lbl_02.getText()+"',"+Matetree.txthost.getText()+")";           
            sql = Matekdd.CC.Ejecutar(sql,2); 
            long time = System.currentTimeMillis(); 
                       
            sql = "SELECT * FROM matetree('"+Matetree.lbl_02.getText()+"')";           
            sql = Matekdd.CC.Ejecutar(sql,2);            
            tiempo = (double)(System.currentTimeMillis() - time);
            
            validar("mate");
            tmp = (double)(System.currentTimeMillis()-tmp);            
            Matetree.ren += "\n\n";
            Matetree.ren +="TIEMPO: "+tiempo/1000+" Sg. - Creacion del Modelo";                
            sql = "CREATE TABLE mate"+Preprocesamiento.lbl_tabla.getText()+Matetree.ccm+" AS SELECT * FROM mate_nodes";            
            Matekdd.CC.Ejecutar(sql,2);
            Matetree.mod.addElement("mate"+Preprocesamiento.lbl_tabla.getText()+Matetree.ccm);
            sql = "DROP TABLE mate_rules";
            Matekdd.CC.Ejecutar(sql,2);
            sql = "DROP TABLE mate_nodes";
            Matekdd.CC.Ejecutar(sql,2);    
            Matekdd.CC.Ejecutar("DROP TABLE kdd_entro",2);
            Matetree.lbl_est.setText("Termino MATETREE OK ("+(tmp/1000)+" Sg.)");                 
            detienecuenta();
             
            
        }catch(Exception e){
            //JOptionPane.showMessageDialog(this,e.toString(),"MATETREE",JOptionPane.ERROR_MESSAGE);
            Matetree.ba = 3;
            Algoritmo_Matetree.detienecuenta();
        }
                Matetree.lst_1.setListData(Matetree.mod);            
                Matetree.txta.setText(Matetree.ren);
                Matetree.modelos.add(Matetree.ren);   
   
            }
            else{
                Matetree.ba = 1;
                detienecuenta();
                //JOptionPane.showMessageDialog(Matetree,"El Algoritmo No Procesa Atributos Numericos!!"+'\n'+"Debe Discretizar en la Etapa de Preprocesamiento","MATETREE",JOptionPane.ERROR_MESSAGE);
            }
         }
         else{
            Matetree.ba=2;
            detienecuenta();
             //JOptionPane.showMessageDialog(Matetree,"ERROR: No Hay Conexion!!","MATETREE",JOptionPane.ERROR_MESSAGE);
         }

         }
         
         public static void detienecuenta(){
             synchronized(Matetree.objeto)
             {
                 Matetree.barra.setVisible(false);
                 Matetree.pideparar = true;
                 Matetree.objeto.notify();
                 Matetree.hilo=null;
             }
         }
}

  
   class ThreadCarga1 extends Thread {
       public void run() {
           int min = 0;
           int max = 100;
           
           Matetree.barra.setValue(min);
           Matetree.barra.setMinimum(min);
           Matetree.barra.setMaximum(max);        
                   
           for( int i=min; i<= max; i=i+10){
               
               Matetree.barra.setValue(i);
               synchronized( Matetree.objeto ){
                   if (Matetree.pideparar)
                    break;
                   try {
                       Matetree.objeto.wait(100);
                       
                   } catch(InterruptedException e){
                       //se ignoran las ex
                   }
                    if (i==100) i=min;
               }
           }        
                              
                   
       }
   }
