package paquetes;
/*
 * Modeltree.java
 *
 * Created on 30 de agosto de 2016, 11:22 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Claudia
 */
import java.util.Vector;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
 * Clase que implementa la interfaz TreeModel y sus metodos 
 *
 * @author Tariy
 */
public class Modeltree implements TreeModel {
    private Vector treeModelListeners = new Vector();
    private createTree root;
    
    /** Creates a new instance of TariyNTreeModel */
    public Modeltree(createTree root) {
        this.root = root;
    }
    
    // Implementacion de los metodos de la interfaz TreeModel  
    // aqui utilizamos los metodos que escribimos en la clase Node
    
    public void addTreeModelListener(TreeModelListener l) {
        treeModelListeners.addElement(l);
    }
    
    public Object getChild(Object parent, int index) {
        createTree n = (createTree) parent;
        return n.getChild(index);
    }
    
    public int getChildCount(Object parent) {
        createTree n = (createTree) parent;
        return n.getChildCount();
    }
    
    public int getIndexOfChild(Object parent, Object child) {
        createTree n = (createTree) parent;
        return n.getIndexOfChild(child);
    }
    
    public Object getRoot() {
        return this.root;
    }
    
    public boolean isLeaf(Object node) {
        createTree n = (createTree) node;
        return n.isLeaf() == null;
    }
    
    public void removeTreeModelListener(TreeModelListener l) {
        treeModelListeners.removeElement(l);
    }
    
    public void valueForPathChanged(TreePath path, Object newValue) {
        System.out.println("*** valueForPathChanged : "
                           + path + " --> " + newValue);
    }
}
