CREATE OR REPLACE FUNCTION sliq(varchar) RETURNS SETOF varchar AS' --clase
DECLARE
		
	ban		integer;
	con		integer;
	cona		integer;
		
	Gan		float;
	Gan_may		float;
	div		float;
	naux		float;
	nant		float;
		
	attgan		text DEFAULT NULL;
	attganv		text DEFAULT NULL;
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	sql2		text DEFAULT '''';
	atributos	text DEFAULT NULL;
	condicion	text DEFAULT NULL;
	prueba		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN
	
--**CREA TABLA DE REGLAS

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_rules'''''' LOOP
		EXECUTE ''DROP TABLE sliq_rules'';
	END LOOP;	
	EXECUTE ''CREATE TABLE sliq_rules (n int2,id int2,atributo bpchar,valor bpchar,com bpchar,tipo int2)'';	

--**CREA TABLA sliq_cond

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_cond'''''' LOOP
		EXECUTE ''DROP TABLE sliq_cond'';
	END LOOP;
	
	EXECUTE ''CREATE TABLE sliq_cond(att varchar,valor bpchar,tipo int2)'';

--**CREA TABLA AUXILIAR pg_col

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_col'''''' LOOP
		EXECUTE ''DROP TABLE pg_col'';
	END LOOP;
	
	EXECUTE ''CREATE TABLE pg_col(n int2,id int2, att varchar,valor bpchar,com bpchar,tipo int2)'';
	EXECUTE ''INSERT INTO pg_col VALUES(0,0,''''''||$1||'''''',NULL,''''='''',2)'';
	
--**CREA TABLA DE NODOS
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''sliq_nodes'''''' LOOP
		EXECUTE ''DROP TABLE sliq_nodes'';	
	END LOOP;
	
	EXECUTE ''CREATE TABLE sliq_nodes (nodo int2,padre int2,hijo int2,atributo bpchar,valor bpchar,com bpchar)'';

--**ARMA SUBGRUPO A MINAR
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''viewsliq'''''' LOOP
		EXECUTE ''DROP VIEW viewsliq'';	
	END LOOP;
	EXECUTE ''CREATE VIEW viewsliq AS SELECT * FROM kdd_ent'';	
	
--**ENCONTRAR ATRIBUTO DEL NODO1
	
	EXECUTE ''SELECT * FROM sliq_gini(''''''||$1||'''''')'';

--**SE INSERTA EL NODO PADRE

	FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP		
	END LOOP;
	
	sql2 := ''SELECT att,valor,com FROM pg_col WHERE n=''||rec1.mx;
	
	FOR rec2 IN EXECUTE sql2 LOOP
		sql1 := ''INSERT INTO sliq_nodes VALUES(1,-1,0,''||''''''''||rec2.att||'''''',''||''''''''||rec2.valor||'''''',''''''||rec2.com||'''''')'';
		EXECUTE sql1;	
	END LOOP;	
	
	EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
	
	EXECUTE ''DROP TABLE pg_col'';
	EXECUTE ''DROP TABLE sliq_cond'';
	EXECUTE ''DROP VIEW viewsliq'';
	
	RETURN NEXT ''CREADA TABLA sliq_rules'';
	RETURN NEXT ''CREADA TABLA sliq_nodes'';
	
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);