CREATE OR REPLACE FUNCTION process_add(varchar,varchar,integer,float,varchar,integer) RETURNS SETOF varchar AS '
/* Funcion que adicion un atributo a la tabla su sparametros son: nombre de la tabla,nombre nuevo att, 
 * numero att1, numero att2, funcion (+,-,*,/), opcion.
 * Si opcion igual a 0 --> la operacion es entre dos atributo de la tabla
 * Si opcion igual a 1 --> la operacion es entre un atributo de la tabla y un valor
*/
DECLARE
	
	ban		integer;
	cont		integer;
	num		integer;
	
	sql		text DEFAULT '''';	
	sql1		text DEFAULT NULL;
	att1		text DEFAULT NULL;
	tipo		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	tabla		text DEFAULT NULL;	
		
	rec1		record;		
	
	
BEGIN

	ban := 0;
	tabla := $1||''a'';
	
	sql := ''SELECT attname,atttypid,typname FROM pg_class, pg_attribute,pg_type''
		|| '' WHERE pg_class.relname = ''''''||$1||''''''''
		|| '' AND pg_type.oid = atttypid AND pg_attribute.attrelid = pg_class.oid AND attnum=''||$3;
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 700 OR rec1.atttypid = 1700 OR rec1.atttypid = 701 THEN
			   ban :=1;
			   att1 := rec1.attname;
			   tipo := rec1.typname;
		END IF;
	END LOOP;
	
	IF $6 = 0 AND ban = 1 THEN -- OPERACION ENTRE DOS ATRIBUTOS
		
		num := CAST($4 as int4);
		sql := ''SELECT attname,atttypid FROM pg_class, pg_attribute''
		|| '' WHERE pg_class.relname = ''''''||$1||''''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid AND attnum=''||num;
	
		FOR rec1 IN EXECUTE sql LOOP
	
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 700 OR rec1.atttypid = 1700 OR rec1.atttypid = 701 THEN
				sql1 := ''UPDATE ''||tabla||'' SET ''||$2||'' = ''||att1||$5||rec1.attname;
			ELSE
				ban :=0;
			END IF;
		END LOOP;
	ELSE
		IF $6 = 1 AND ban = 1 THEN -- OPERACION ENTRE UN ATRIBUTO Y UN NUMERO
			IF $4 > 0 THEN
				sql1 := ''UPDATE ''||tabla||'' SET ''||$2||'' = ''||att1||$5||$4;
			ELSE
				ban := 0;
			END IF;
		
		END IF; 
	END IF;
	
	IF ban = 1 THEN
	
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
			EXECUTE ''DROP TABLE ''||tabla;	
		END LOOP;
		
		EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM ''||$1;
		
		sql := ''ALTER TABLE ''||tabla||'' ADD ''||$2||'' ''||tipo;
		
		EXECUTE sql;
		EXECUTE sql1;
		
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''fl_''||$1||'''''''' LOOP	
			EXECUTE ''DROP TABLE fl_''||$1;	
		END LOOP;
		EXECUTE ''CREATE TABLE fl_''||$1||'' AS SELECT * FROM ''||tabla;
		EXECUTE ''DROP TABLE ''||tabla;	
		RETURN NEXT ''fl_''||$1;
	ELSE
		RETURN NEXT null;
	END IF;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);