CREATE OR REPLACE FUNCTION type_rules(varchar) RETURNS varchar AS '
DECLARE
	associator	ALIAS FOR $1;
	
	qry_sql		text DEFAULT '''';
	cad_type	text DEFAULT NULL;
	
	rec_type	record;
	
BEGIN
	--****	CREA TIPO rules
	
	qry_sql := ''SELECT attname from pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''''||associator||'''''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 AND attnum < relnatts ORDER BY attnum'';
		
	FOR rec_type IN EXECUTE qry_sql LOOP
	
		IF cad_type ISNULL THEN cad_type := rec_type.attname||'' bpchar'';
		ELSE cad_type := cad_type ||'' , ''|| rec_type.attname||'' bpchar'';
		END IF;
	
	END LOOP;
	cad_type := cad_type||'' , ''||''n_regla int2 , implica bpchar , soporte int2 , confianza numeric'';
	EXECUTE ''CREATE TYPE rules AS (''||cad_type||'')'';
	--****
	RETURN ''CREATE TYPE'';
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
