#include "defs.h"
#include "arbol.c"
#include "busqueda.c"
#include "nodeArbolaTabla.c"

Datum	gain_main(PG_FUNCTION_ARGS);

PG_FUNCTION_INFO_V1(gain_main);

Datum
gain_main(PG_FUNCTION_ARGS)
{
	text	   *relname = PG_GETARG_TEXT_P(0);
	int numClases[30];
	int numAttr;
	int NCLASES;
	
	setDatos(&numAttr,&NCLASES,numClases);
	
	//elog(INFO,"numatt=%d NCLASES=%d",numAttr,NCLASES);
	NodoArbol	*raiz,*aux;
	raiz = (NodoArbol *)malloc(sizeof(NodoArbol));
	aux = (NodoArbol *)malloc(sizeof(NodoArbol));
	raiz->padre = NULL;
	raiz->nHijos=0;
	aux = raiz;
	
	int flag=0,i=0;
	int *vecdec;
	int **matriz;
	vecdec = nuevoArreglo(int, 50);
	matriz = nuevoArreglo(int *, 2);
	matriz[0] = nuevoArreglo(int, numAttr);
	matriz[1] = nuevoArreglo(int, numAttr);
	
	do{
		inicializarMatriz(&matriz,numAttr);
		recorrerArbol(&matriz,raiz,numAttr,aux);

		if(matriz[0][0]==-1 && i!=0){
			flag=1;	break;
		}
	
		busqueda(vecdec,relname,numAttr,NCLASES,numClases,matriz);

		if(i==0)//para creal la raiz....
			crearNodo(raiz,vecdec,NCLASES,numClases);
		else{
			iniciarX(0);//para crear el resto de nodos
			encontrarNodo( raiz,vecdec,NCLASES,numClases);
		}
		i++;
	} while (flag==0) ;
	
	//mostrarArbol( raiz );
	
	Decision3State	*decstate;
	decstate = makeD3S();
	decstate->raiz = raiz;
	//decstate->nNodos = 1;
	decstate->indice = 0;
	elog(LOG,"Iniciando creacion de Tabla contenedora de nodos ");
	TablaArbol(decstate);
	TablaRules(decstate);
	//liberarD3S(decstate);

	traducirReglasClasificacion(1);
	liberar(vecdec);
	liberarMatriz(matriz,numAttr);
//	liberarArbol(raiz);
//	liberar(raiz);

	PG_RETURN_INT32(1);
}

