CREATE TYPE nodes AS (nodo int2 , padre int2 , atributo varchar , valor varchar , etiqueta varchar);

CREATE OR REPLACE FUNCTION gain(varchar) RETURNS SETOF nodes AS '
DECLARE
	qry_sql		text DEFAULT '''';
	cad_int		text DEFAULT NULL;
	flag_val	text DEFAULT NULL;
	
	rec_at		record;
	rec_nodes	nodes%ROWTYPE;
	
BEGIN
	--****	PROCESO DE PRESENTACION DEL ARBOL DE DECISION
	
	IF $1 <> ''mate_entro'' THEN
		RAISE EXCEPTION ''Tabla ''''%'''', no valida'',$1;
		RETURN;
	END IF;
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''tclases'';
	IF flag_val IS NOT NULL THEN
		RAISE EXCEPTION ''La tabla de CLASIFICACION tclases, ya existe'';
		RETURN;
	END IF; 
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''trulesclases'';
	IF flag_val IS NOT NULL THEN
		RAISE EXCEPTION ''La tabla de CLASIFICACION trulesclases, ya existe'';
		RETURN;
	END IF; 
	
	qry_sql := ''SELECT gain_main(''''mate_entro'''')'';
	EXECUTE qry_sql;

	FOR rec_nodes IN EXECUTE ''SELECT * FROM mate_nodos'' LOOP
		RETURN NEXT rec_nodes;
	END LOOP;
	--****
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
