CREATE OR REPLACE FUNCTION sliq_tree(INTEGER,VARCHAR) RETURNS SETOF VARCHAR AS'--NODO,CLASE
DECLARE
		
	bclas		integer;
	con		integer;
	cona		integer;
	ipg		integer;
	op		integer;
	nodo		integer;
		
	Gan		float;
	Gan_may		float;
	div		float;
	naux		float;
	nant		float;
	
	attgan		text DEFAULT NULL;
	clase		text DEFAULT NULL;
	attganv		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	sql2		text DEFAULT '''';
	atributos	text DEFAULT NULL;
	condicion	text DEFAULT NULL;
	prueba		text DEFAULT NULL;
	aux		varchar;
			
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN
	IF $1 = 0 THEN -- ENCONTRAR EL VALOR DEL NODO RAIZ
		
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''viewc1'''''' LOOP
			EXECUTE ''DROP TABLE viewc1 CASCADE'';	
		END LOOP;
		EXECUTE ''CREATE TABLE viewc1 AS SELECT * FROM kdd_ent'';
		FOR rec1 IN EXECUTE ''SELECT COUNT(*) AS t FROM viewc1'' LOOP
			cona := rec1.t;
		END LOOP;

		EXECUTE ''SELECT * FROM sliq_gini(0,0,''''''||$2||'''''',''||cona||'')'';
		
		nodo := 1;
		op := 1;		
	ELSE	
		EXECUTE ''SELECT * FROM sliq_set()'';
		FOR rec1 IN EXECUTE ''SELECT COUNT(*) AS t FROM viewc1'' LOOP
			cona := rec1.t;
		END LOOP;

		FOR rec1 IN EXECUTE ''SELECT * FROM sliq_gini(0,''||$1||'',''''''||$2||'''''',''||cona||'')'' LOOP			
			IF rec1.sliq_gini != -1 THEN
				nodo := rec1.sliq_gini;
				op := 1;
			ELSE	
				op := 0;
			END IF;
		END LOOP;		
	END IF;	
	
	WHILE op = 1 LOOP -- BUSCAR COMBINACIONES RAMAS

			sql := NULL;
			FOR rec1 IN EXECUTE ''SELECT * FROM sliq_nodes WHERE nodo=''||nodo LOOP
				cad := rec1.atributo;
			END LOOP;

			FOR rec1 IN EXECUTE ''SELECT * FROM sliq_nodes WHERE atributo=''''''||cad||'''''' AND nodo = ''||nodo LOOP
				IF sql ISNULL THEN
					IF rec1.valor != ''-1'' THEN
						IF rec1.com = ''='' THEN
							sql := rec1.atributo||''=''''''||rec1.valor||'''''''';
						ELSE
							sql := rec1.atributo||rec1.com||rec1.valor;
						END IF;
					END IF;
				ELSE	
					IF rec1.valor != ''-1'' THEN
						sql := sql ||'' OR ''||rec1.atributo||''=''''''||rec1.valor||'''''''';
					END IF;
				END IF;
			END LOOP;
						
			sql := ''DELETE FROM viewc1 WHERE ''||sql;	
			EXECUTE sql;	
			
			FOR rec1 IN EXECUTE ''SELECT * FROM sliq_gini(1,''||nodo||'',''''''||$2||'''''',''||cona||'')'' LOOP
				
				IF rec1.sliq_gini != -1 THEN
					nodo := rec1.sliq_gini;
					op := 1;
				ELSE	
					op := 0;					
				END IF;
			END LOOP;
		END LOOP;

	RETURN NEXT ''OK'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
