CREATE OR REPLACE FUNCTION process_del(varchar,varchar) RETURNS SETOF varchar AS '
/* Funcion clearAtt recibe como parametro el nombre de la tabla y el nombre del atributo que se 
 * va a    eliminar como resultado crea la tabla fl+tabla 
*/
DECLARE
	
	i		integer;
	cont		integer;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	cada		text DEFAULT NULL;
	tabla		text DEFAULT NULL;
		
	rec1		record;	
	oid		integer;
	
	flag_val	text;
	
BEGIN

--****	CREA TABLA tablaE

	tabla = $1 ||''e'';
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	
	EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM ''||$1;	
	
	EXECUTE ''ALTER TABLE ''||tabla||'' DROP ''||$2;  
		
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''fl_''||$1||'''''''' LOOP	
			EXECUTE ''DROP TABLE fl_''||$1;	
	END LOOP;
	EXECUTE ''CREATE TABLE fl_''||$1||'' AS SELECT * FROM ''||tabla;
	EXECUTE ''DROP TABLE ''||tabla;	
	RETURN NEXT ''fl_''||$1;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);