CREATE OR REPLACE FUNCTION process_dtz(varchar,int,int)RETURNS SETOF bpchar AS'
DECLARE
	i		integer;
	j		integer;	
	ini		integer DEFAULT 0;
	fin		integer;
	modo		float;
	cont_reg	integer DEFAULT 0;
	aux		integer;
	
	max		numeric(10,3);
	min		numeric(10,3);
	inc		numeric(10,3);	
	aux1		numeric(10,3);
	aux2		numeric(10,3);
	tope 		numeric(10,3);
	
	nr		text DEFAULT '''';
	nombre		text DEFAULT '''';
	qry_sql		text DEFAULT '''';
	qry_sql2	text DEFAULT '''';
	qry_sql3	text DEFAULT '''';
	
	cad_var		text DEFAULT NULL;
	cad_join	text DEFAULT NULL;
	cad_join2	text DEFAULT NULL;
	cad_int		text DEFAULT NULL;
	flag_val	text DEFAULT NULL;
	
	rec1		record;
	rec_at		record;
	rec_att		record;
	
BEGIN


--****	CREA TABLA pg_listchar, kdd_discret

	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''pg_listchar'';
	IF flag_val IS NOT NULL THEN		
		EXECUTE ''DROP TABLE pg_listchar'';		
	END IF;
	
	
	
	qry_sql := ''SELECT attname, attnum, relnatts, atttypid, typname FROM pg_class, pg_attribute, pg_type'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''''||$1||'''''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND pg_type.oid = atttypid AND attnum > 0 ORDER BY attnum'';
	
		
	IF $3 = 0 THEN
		FOR rec_at IN EXECUTE qry_sql LOOP
		
			IF cad_var ISNULL THEN
				cad_var := rec_at.attname||'' bpchar''; -- concatena el nombre de la variable tipo  bpchar 
				cad_int := rec_at.attname;  --//concatena el nombre del atributo para luego hacer la consulta
				
				IF rec_at.atttypid = 20 OR rec_at.atttypid = 21 OR rec_at.atttypid = 22 OR rec_at.atttypid = 23 OR rec_at.atttypid = 700 OR rec_at.atttypid = 1700 OR rec_at.atttypid = 701 THEN   --// el atributo es de tipo numerico
				cad_join:= cad_int||'' numeric(10,3)'';  --//concatena el nombre del atributo y el tipo numeric
				ELSE
				cad_join:= cad_int||'' ''|| rec_at.typname;
				END IF;
			ELSE
				cad_var := cad_var ||'' , ''|| rec_at.attname||'' bpchar'';
				cad_int := cad_int ||'' , ''|| rec_at.attname;
				
				IF rec_at.atttypid = 20 OR rec_at.atttypid = 21 OR rec_at.atttypid = 22 OR rec_at.atttypid = 23 OR rec_at.atttypid = 700 OR rec_at.atttypid = 1700 OR rec_at.atttypid = 701 THEN
				cad_join:= cad_join||'',''||rec_at.attname||'' numeric(10,3)'';
				ELSE
				cad_join:= cad_join||'',''||rec_at.attname||'' ''||rec_at.typname;
				END IF;
			END IF;
		END LOOP;
	ELSE
	FOR rec_at IN EXECUTE qry_sql LOOP
			
			IF cad_var ISNULL THEN
				
				cad_int := rec_at.attname;  --//concatena el nombre del atributo para luego hacer la consulta
				
				IF (rec_at.atttypid = 20 OR rec_at.atttypid = 21 OR rec_at.atttypid = 22 OR rec_at.atttypid = 23 OR rec_at.atttypid = 700 OR rec_at.atttypid = 1700 OR rec_at.atttypid = 701) AND rec_at.attnum != $3 THEN   
					cad_join:= cad_int||'' numeric(10,3)''; 
					cad_var:= cad_int||'',''||rec_at.attname||'' numeric(10,3)'';
				ELSE
					cad_join:= cad_int||'' ''|| rec_at.typname;
					cad_var:= cad_int||'' ''|| '' bpchar'';
				END IF;
			ELSE
				cad_int := cad_int ||'' , ''|| rec_at.attname;
				
				IF (rec_at.atttypid = 20 OR rec_at.atttypid = 21 OR rec_at.atttypid = 22 OR rec_at.atttypid = 23 OR rec_at.atttypid = 700 OR rec_at.atttypid = 1700 OR rec_at.atttypid = 701) AND rec_at.attnum != $3 THEN
				
					cad_join:= cad_join||'',''||rec_at.attname||'' numeric(10,3)'';
					cad_var:= cad_var||'',''||rec_at.attname||'' numeric(10,3)'';
				
				ELSE
					cad_join:= cad_join||'',''||rec_at.attname||'' ''||rec_at.typname;
					cad_var:= cad_var||'',''||rec_at.attname||'' ''||'' bpchar'';
				END IF;
			END IF;
		END LOOP;
		
	END IF;
	 
	cad_join2:= cad_var;
	cad_var := cad_var || '',num int2'';
	cad_join := cad_join || '',num int2'';

	EXECUTE ''CREATE TABLE pg_listchar(''||cad_var||'')'';  --//crea la tabla con todos los atributos tipo bpchar
	EXECUTE ''INSERT INTO pg_listchar SELECT * FROM ''||$1;
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''kdd_discret'';
	IF flag_val IS NOT NULL THEN		
		EXECUTE ''DROP TABLE kdd_discret'';
	END IF;	
	
	EXECUTE ''CREATE TABLE kdd_discret(''||cad_join||'')'';  --//crea una tabla aparentemente igual que la original
	EXECUTE ''INSERT INTO kdd_discret SELECT * FROM ''||$1;
	
	FOR rec1 IN EXECUTE ''SELECT count(*) as cc FROM pg_listchar'' LOOP
	END LOOP;
	cont_reg :=  rec1.cc;

	j := 1;
	FOR rec1 IN EXECUTE ''SELECT ctid FROM pg_listchar'' LOOP  --// transforma cada todos
		qry_sql := rec1.ctid;	

		EXECUTE ''UPDATE pg_listchar SET num =''||j||'' WHERE ctid=''''''||qry_sql||'''''''';		
		j := j + 1;
	END LOOP;
	j := 1;
	FOR rec1 IN EXECUTE ''SELECT ctid FROM kdd_discret'' LOOP
		qry_sql := rec1.ctid;	
		EXECUTE ''UPDATE kdd_discret SET num =''||j||'' WHERE ctid=''''''||qry_sql||'''''''';
		j := j + 1;
	END LOOP;
	
	

--****	CREA TABLA pg_rangos

	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''pg_rangos'';
	IF flag_val ISNULL THEN
		 EXECUTE ''CREATE TABLE pg_rangos(nro int2,atributo bpchar, min numeric(10,3), max numeric(10,3),equivalente bpchar,rangos int2)'';
	END IF;	

	IF $3 = 0 THEN

--**seleccionar max y min
		qry_sql := ''SELECT attname AS nombre, atttypid AS modo FROM pg_class, pg_attribute'';
		qry_sql := qry_sql || '' WHERE pg_class.relname = '''''' || $1 || '''''''';
		qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
		qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
		
		j := 1;
		
		FOR rec_at IN EXECUTE qry_sql LOOP
		modo := rec_at.modo;
		
			IF modo = 20 OR modo = 21 OR modo = 22 OR modo = 23 OR modo = 700 OR modo = 1700 OR 
			modo = 701 THEN
			
				qry_sql2 := ''SELECT max('' || rec_at.nombre || '') AS maxi, min('';
				qry_sql2 := qry_sql2 || rec_at.nombre || '') As mini FROM kdd_discret''; 
				
			FOR rec_att IN EXECUTE qry_sql2 LOOP
				
				max := CAST(rec_att.maxi AS float);
				min := CAST(rec_att.mini AS float);
				inc := (max - min)/$2;
				i := 0;
				aux1 := min;
				tope := min + inc;
				aux2 := tope;
				
				WHILE i < $2 LOOP 
				
					IF i = $2-1 then
						tope := max + 0.001;
						nr := ''[''||aux1||'',''||tope||'']'';
					ELSE 
						tope := tope;
						nr := ''[''||aux1||'',''||tope||'')'';
					END IF;
				
				qry_sql3 := ''INSERT INTO pg_rangos VALUES ''; 
				qry_sql3 := qry_sql3 || ''(''||j||'',''''''||rec_at.nombre||'''''',''||aux1;
				qry_sql3 := qry_sql3 || '',''||tope||'',''''''||nr||'''''',''||$2||'')'';
				
				EXECUTE qry_sql3;
				i := i + 1;
				j := j + 1;	
				nr := ''r'';
				aux1 := aux2;
				tope := aux2;
				tope := tope + inc;
				aux2 := tope;
				
				END LOOP;
		
			END LOOP; 			
			END IF;
		END LOOP;
	ELSE 
		qry_sql := ''SELECT attname AS nombre, atttypid AS modo FROM pg_class, pg_attribute'';
		qry_sql := qry_sql || '' WHERE pg_class.relname = '''''' || $1 || '''''''';
		qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
		qry_sql := qry_sql || '' AND attnum =''||$3;
		
		j := 1;
		
		FOR rec_at IN EXECUTE qry_sql LOOP
		modo := rec_at.modo;
		
			IF modo = 20 OR modo = 21 OR modo = 22 OR modo = 23 OR modo = 700 OR modo = 1700 OR 
			modo = 701 THEN
			
				qry_sql2 := ''SELECT max('' || rec_at.nombre || '') AS maxi, min('';
				qry_sql2 := qry_sql2 || rec_at.nombre || '') As mini FROM kdd_discret''; 
				
			FOR rec_att IN EXECUTE qry_sql2 LOOP
				
				max := CAST(rec_att.maxi AS float);
				min := CAST(rec_att.mini AS float);
				
				inc := (max - min)/$2;
				i := 0;
				aux1 := min;
				tope := min + inc;
				aux2 := tope;
				
				WHILE i < $2 LOOP
				
					IF i = $2-1 then
						tope := max + 0.001;
						nr := ''[''||aux1||'',''||tope||'']'';
					ELSE 
						tope := tope;
						nr := ''[''||aux1||'',''||tope||'')'';
					END IF;
				
				qry_sql3 := ''INSERT INTO pg_rangos VALUES ''; 
				qry_sql3 := qry_sql3 || ''(''||j||'',''''''||rec_at.nombre||'''''',''||aux1;
				qry_sql3 := qry_sql3 || '',''||tope||'',''''''||nr||'''''',''||$2||'')'';
				EXECUTE qry_sql3;
				i := i + 1;
				j := j + 1;	
				nr := ''r'';
				aux1 := aux2;
				tope := aux2;
				tope := tope + inc;
				aux2 := tope;
				
				END LOOP;
		
			END LOOP; 			
			END IF;
		END LOOP;
		
	END IF;

--**	PROCESO DE TRANSFORMACION a pg_listchar
       	
	qry_sql3 := ''SELECT * FROM pg_rangos''; 
	
	FOR rec_at IN EXECUTE qry_sql3 LOOP
		
	   max := CAST(rec_at.max as numeric(10,3));
	   min := CAST(rec_at.min as numeric(10,3));
	   
	   qry_sql2 := ''SELECT num AS nro FROM kdd_discret WHERE ''||rec_at.atributo||'' >= ''||rec_at.min||'' AND ''||rec_at.atributo||'' < ''||rec_at.max;
	   
	   FOR rec1 IN EXECUTE qry_sql2 LOOP
			
		qry_sql := ''UPDATE pg_listchar SET ''||rec_at.atributo||'' = ''''''||rec_at.equivalente
			||''''''''|| '' WHERE num=''||rec1.nro;
		
		IF qry_sql IS NOT NULL THEN	
			EXECUTE qry_sql;	
		END IF;
		
	   END LOOP;
	   
	END LOOP;

 --** TABLA kdd_discret
	
 	EXECUTE ''DROP TABLE kdd_discret'';	
	nr := ''fl_''||$1;
	SELECT INTO flag_val relname FROM pg_class WHERE relname = nr;
	IF flag_val IS NOT NULL THEN		
		EXECUTE ''DROP TABLE ''||nr;		
	END IF;
	
	qry_sql := ''CREATE TABLE ''||nr||''(''||cad_join2||'')'';
	EXECUTE qry_sql;
	
	qry_sql := ''INSERT INTO ''||nr||'' SELECT ''||cad_int||'' FROM  pg_listchar'';
	EXECUTE qry_sql;
	
	EXECUTE ''DROP TABLE pg_listchar'';	
	RETURN NEXT nr;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
