CREATE OR REPLACE FUNCTION filter(varchar) RETURNS SETOF varchar AS '
DECLARE
	
	i		integer;	
	
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	attb		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	clase		text DEFAULT NULL;
	tabla		bpchar DEFAULT NULL;
		
	rec1		record;	
	rec2		record;	
	rec3		record;	
	
	p_may		numeric;
	pb		numeric;
	
BEGIN

--****	CREA TABLA tablaF

	tabla = ''pg_kdd_tmp'';	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM kdd_ent'';
	
	sql := ''SELECT attname FROM pg_class, pg_attribute WHERE pg_class.relname = ''''kdd_ent''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1
		|| '''''' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
		IF attb IS NULL THEN
			attb := rec1.attname;
		ELSE
			attb := attb ||'',''|| rec1.attname;
		END IF;
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''pg_tmp_kdd'''''' LOOP	
		EXECUTE ''DROP TABLE pg_tmp_kdd'';	
	END LOOP;
 	EXECUTE ''CREATE TABLE pg_tmp_kdd AS SELECT ''||attb||'',COUNT(*) AS cc FROM kdd_ent GROUP BY ''||attb;
		
	FOR rec1 IN EXECUTE ''SELECT ctid,cc FROM pg_tmp_kdd'' LOOP		
		cad := NULL;
		sql := ''SELECT attname,atttypid FROM pg_class, pg_attribute''
			|| '' WHERE pg_class.relname = ''''kdd_ent''''''
			|| '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1||''''''''
			|| '' AND attnum > 0 ORDER BY attnum'';
			
		FOR rec2 IN EXECUTE sql LOOP
			sql1 := rec1.ctid;
			sql1:=''SELECT ''||rec2.attname||'' AS at FROM pg_tmp_kdd WHERE ctid=''''''||sql1||'''''''';

			FOR rec3 IN EXECUTE sql1 LOOP
				IF rec2.atttypid = 20 OR rec2.atttypid = 21 OR rec2.atttypid = 22 OR rec2.atttypid = 23 OR rec2.atttypid = 700 OR rec2.atttypid = 1700 OR rec2.atttypid = 701 THEN
			   		
					IF cad ISNULL THEN
						cad := rec2.attname||''=''||rec3.at;
					ELSE	
						cad := cad ||'' AND ''||rec2.attname||''=''||rec3.at;
					END IF;
				ELSE
			   		IF cad ISNULL THEN
						cad := rec2.attname||''=''''''||rec3.at||'''''''';
					ELSE
						cad := cad ||'' AND ''||rec2.attname
							||''=''''''||rec3.at||'''''''';
					END IF;
				END IF;
			END LOOP;			
		END LOOP;
		p_may := 0;
		i := 0;
		sql := ''SELECT COUNT(*) AS ct,''||$1||'' as cs FROM kdd_ent WHERE ''||cad||'' GROUP BY ''
			||attb||'',''||$1;			
		FOR rec2 IN EXECUTE sql LOOP
			pb := CAST(rec2.ct as numeric)/CAST(rec1.cc as numeric);
			
			IF pb > p_may THEN
				p_may := pb;
				clase := CAST(rec2.cs as varchar);
			END IF;
			i := i + 1;
		END LOOP;
		
		IF i > 1 THEN
			EXECUTE ''DELETE FROM kdd_ent WHERE ''||cad||'' AND ''||$1||''!=''''''
				||clase||'''''''';
		END IF;
	END LOOP;
	
	EXECUTE ''DROP TABLE pg_tmp_kdd'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

/* Esta funcion balancea la tabla kdd_ent, recibe como parametro el nombre del atributo clase y crea 	
 * una tabla pg_kdd_tmp temporal
*/