CREATE OR REPLACE FUNCTION translate_rules(varchar) RETURNS SETOF varchar AS '--modelo
DECLARE
	
	qry_sql		text DEFAULT '''';	
	cad		text DEFAULT NULL;
	cr		text DEFAULT NULL;
	clase		text DEFAULT '''';
	
	rec_at		record;
	rec1		record;
	
BEGIN

--****	TRADUCE LAS REGLAS
	
	cad := ''id bpchar,atributo bpchar,valor bpchar'';
	
	EXECUTE ''COPY ''||$1||''_rules TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE ''||$1||''_rules'';
	EXECUTE ''CREATE TABLE ''||$1||''_rules (''||cad||'')''; 
	EXECUTE ''COPY ''||$1||''_rules FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_rules SET atributo=''''''||rec_at.attname||'''''' WHERE atributo=''''''||rec_at.attnum||'''''''';	
		EXECUTE cad;	
		
	END LOOP;
		
	qry_sql := ''SELECT atributo,valor,discret from kdd_values'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_rules SET valor=''''''||rec_at.valor||'''''' WHERE atributo=''''''||rec_at.atributo||'''''' AND valor=''''''||rec_at.discret||'''''''';	
		EXECUTE cad;
		
	END LOOP;
	
	cad := ''UPDATE ''||$1||''_rules SET valor='''''''' WHERE valor = ''''-999'''''';
	EXECUTE cad;	
	
--**TRADUCE LOS NODOS

	cad := ''nodo int2,padre int2,atributo bpchar,valor bpchar,hijo int2, herm int2,clase bpchar'';
	
	EXECUTE ''COPY ''||$1||''_nodes TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE ''||$1||''_nodes'';
	EXECUTE ''CREATE TABLE ''||$1||''_nodes (''||cad||'')''; 
	EXECUTE ''COPY ''||$1||''_nodes FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_nodes SET atributo=''''''||rec_at.attname||'''''' WHERE atributo=''''''||rec_at.attnum||'''''''';	
		EXECUTE cad;
		
		IF (rec_at.attnum = rec_at.relnatts) THEN
			
			clase := rec_at.attname;
			
		END IF;
	END LOOP;
		
	qry_sql := ''SELECT atributo,valor,discret FROM  kdd_values '';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_nodes SET valor=''''''||rec_at.valor||'''''' WHERE atributo=''''''||rec_at.atributo||'''''' AND valor=''''''||rec_at.discret||'''''''';	
		EXECUTE cad;		
		IF rec_at.atributo = clase THEN
			cad := ''UPDATE ''||$1||''_nodes SET clase=''''''||rec_at.valor||'''''' WHERE clase=''''''||rec_at.discret||'''''''';
				EXECUTE cad;		
		END IF;
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_rangos'''''' LOOP
		EXECUTE ''SELECT * FROM translate_inte(''''''||clase||'''''',''''''||$1||'''''')'';
	END LOOP;	
	
	EXECUTE ''DROP TABLE kdd_values'';
	EXECUTE ''DROP TABLE kdd_ent'';	
	
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
