/*
 * Sliq.java
 *
 * Created on 2 de agosto de 2016, 9:47
 */

package Iprincipal;

import AsistenteConexion.*;
import java.awt.event.*;
import java.io.File;
import java.sql.ResultSet;
import java.util.Date;
import java.util.*;
import javax.swing.*;
import paquetes.*;

/**
 *
 * @author  ivan
 */
public class Sliq extends javax.swing.JPanel {
    
   JPopupMenu popup = new JPopupMenu();    
    public static Vector mod = new Vector();
    public static String ren;
    public static Vector modelos = new Vector();
    private JFileChooser fc = new JFileChooser();
    public static int Rpru;
    private double tiempo;
    public static int ccm;
    public static ThreadCarga2 hilo = null;
    public static int ba = 0; 
    public static Object objeto = new Object();
    public static boolean pideparar = false;
    
    public Sliq() {
        initComponents();       
        barra.setVisible(false);
        this.setSize(675, 430);      
        String arc; 
        File dr = new File("/opt/Matekdd/models/");
        fc.setCurrentDirectory(dr);
        ActionListener  al = new ActionListener(){
            public void actionPerformed( ActionEvent evt){
                        String cadena = new String(((JMenuItem)evt.getSource()).getText());
                        ExampleFileFilter ext = new ExampleFileFilter(".mtr", "Modelos de Matekdd");
                        String archivo;                
                        if(cadena.compareTo("Guardar Modelo") == 0){                            
                            fc.setDialogTitle("Guardar Modelo");
                            fc.setApproveButtonText("Save");                    
                            int returnVal = fc.showOpenDialog(Sliq.this);
                            if (returnVal == JFileChooser.APPROVE_OPTION) {
                                File f = fc.getSelectedFile();
                                String dir = new String(fc.getCurrentDirectory().toString());                        
                                String arc = new String(fc.getName(f));   
                                String res = Mfiles.GuardarMod(dir,arc+".mtr",3);                        
                                if (res.length()<=0){
                                    JOptionPane.showMessageDialog(Sliq.this,"Error: al Guardar !","SLIQ",JOptionPane.ERROR_MESSAGE);
                                }else{
                                    int id = lst_1.getSelectedIndex();
                                    String sql = new String("CREATE TABLE "+arc+" AS SELECT * FROM "+lst_1.getSelectedValue().toString());                                    
                                    //System.out.println(sql);
                                    Matekdd.CC.Ejecutar(sql,2);
                                    sql = "SELECT * FROM save_tree('"+lst_1.getSelectedValue().toString()+"','"+arc+"',1,'"+dir+"',2)";
                                   // System.out.println(sql);
                                    Matekdd.CC.Ejecutar(sql,2);
                                    Matekdd.CC.Ejecutar("DROP TABLE "+lst_1.getSelectedValue().toString(),2);
                                    mod.remove(id);
                                    ren = modelos.elementAt(id).toString();                            
                                    modelos.remove(id);
                                    modelos.add(ren);
                                    mod.addElement(arc);
                                    lst_1.setListData(mod);
                                    JOptionPane.showMessageDialog(Sliq.this,"Modelo Guardado !","SLIQ",JOptionPane.INFORMATION_MESSAGE);
                                }
                            } 
                        }
                    else if(cadena.compareTo("Abrir Modelo") == 0){
                            fc.setDialogTitle("Abrir Modelo");                    
                            int returnVal = fc.showOpenDialog(Sliq.this);
                            if (returnVal == JFileChooser.APPROVE_OPTION) {
                                File f = fc.getSelectedFile();
                                String dir = fc.getCurrentDirectory().toString();                        
                                String arc = fc.getName(f);
                                if (Mfiles.AbrirMod(dir,arc+".mtr",3).length()<=0){
                                    JOptionPane.showMessageDialog(Sliq.this,"Error: al Abrir !","SLIQ",JOptionPane.ERROR_MESSAGE);
                                }else{
                                    mod.addElement(arc);
                                    lst_1.setListData(mod);
                                    Matekdd.CC.Ejecutar("SELECT * FROM save_tree('"+arc+"','"+arc+"',2,'"+dir+"')",2);
                                }                        
                            }
                    }
                   else if(cadena.compareTo("Ver Arbol") == 0){
                       new viewtree(lst_1.getSelectedValue().toString(),1,lbl_02.getText(),"Sliq");
                    }
                }
        };   
        
        
        JMenuItem elemento = new JMenuItem("Abrir Modelo");
        elemento.addActionListener( al );
        popup.add(elemento);
        elemento = new JMenuItem("Guardar Modelo");
        elemento.addActionListener( al );
        popup.add(elemento);
        elemento = new JMenuItem("Ver Arbol");
        elemento.addActionListener( al );
        popup.add(elemento);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        Popc = new javax.swing.JPanel();
        rbtn_1 = new javax.swing.JRadioButton();
        rbtn_2 = new javax.swing.JRadioButton();
        rbtn_3 = new javax.swing.JRadioButton();
        txt_1 = new javax.swing.JTextField();
        txt_2 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        Pmod = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lst_1 = new javax.swing.JList();
        Pred = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txta = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        lbl_02 = new javax.swing.JLabel();
        btn_01 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        lbl_est = new javax.swing.JLabel();
        barra = new javax.swing.JProgressBar();
        jPanel5 = new javax.swing.JPanel();
        lbl_3 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();

        setLayout(null);

        setPreferredSize(new java.awt.Dimension(900, 650));
        Popc.setLayout(null);

        Popc.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Opciones de Prueba ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        buttonGroup1.add(rbtn_1);
        rbtn_1.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_1.setSelected(true);
        rbtn_1.setText("Usar Conjunto de Entrenamiento");
        rbtn_1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_1.setName("rbtn_1");
        rbtn_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_1ActionPerformed(evt);
            }
        });

        Popc.add(rbtn_1);
        rbtn_1.setBounds(10, 30, 230, 15);

        buttonGroup1.add(rbtn_2);
        rbtn_2.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_2.setText("Usar Division de");
        rbtn_2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_2.setName("rbtn_2");
        rbtn_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_2ActionPerformed(evt);
            }
        });

        Popc.add(rbtn_2);
        rbtn_2.setBounds(10, 60, 130, 20);

        buttonGroup1.add(rbtn_3);
        rbtn_3.setForeground(new java.awt.Color(102, 102, 102));
        rbtn_3.setText("Usar");
        rbtn_3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rbtn_3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rbtn_3.setName("rbtn_3");
        rbtn_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtn_3ActionPerformed(evt);
            }
        });

        Popc.add(rbtn_3);
        rbtn_3.setBounds(10, 100, 50, 15);

        txt_1.setEditable(false);
        txt_1.setText("30");
        txt_1.setName("txt_1");
        Popc.add(txt_1);
        txt_1.setBounds(150, 60, 50, 20);

        txt_2.setEditable(false);
        txt_2.setName("txt_2");
        Popc.add(txt_2);
        txt_2.setBounds(70, 100, 50, 20);

        jLabel1.setText("%");
        Popc.add(jLabel1);
        jLabel1.setBounds(210, 60, 20, 20);

        jLabel2.setForeground(new java.awt.Color(102, 102, 102));
        jLabel2.setText("Instancias");
        Popc.add(jLabel2);
        jLabel2.setBounds(140, 100, 100, 20);

        add(Popc);
        Popc.setBounds(10, 190, 260, 130);

        Pmod.setLayout(null);

        Pmod.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lista de Modelos ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        lst_1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lst_1evtpopup(evt);
            }
        });

        jScrollPane2.setViewportView(lst_1);

        Pmod.add(jScrollPane2);
        jScrollPane2.setBounds(10, 30, 240, 160);

        add(Pmod);
        Pmod.setBounds(10, 340, 260, 200);

        Pred.setLayout(null);

        Pred.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Informacion del Modelo", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        txta.setColumns(20);
        txta.setFont(new java.awt.Font("Monospaced", 1, 12));
        txta.setRows(5);
        jScrollPane1.setViewportView(txta);

        Pred.add(jScrollPane1);
        jScrollPane1.setBounds(20, 30, 580, 480);

        add(Pred);
        Pred.setBounds(270, 10, 620, 530);

        jPanel1.setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Atributo Clase ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        lbl_02.setFont(new java.awt.Font("Dialog", 1, 14));
        lbl_02.setForeground(new java.awt.Color(102, 102, 102));
        lbl_02.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lbl_02.setText("A");
        jPanel1.add(lbl_02);
        lbl_02.setBounds(10, 20, 240, 20);

        add(jPanel1);
        jPanel1.setBounds(10, 70, 260, 50);

        btn_01.setFont(new java.awt.Font("Bitstream Vera Sans", 1, 18));
        btn_01.setForeground(new java.awt.Color(102, 102, 102));
        btn_01.setText("Clasificar");
        btn_01.setToolTipText("Crear Modelo de Clasificaci\u00f3n");
        btn_01.setEnabled(false);
        btn_01.setRolloverEnabled(false);
        btn_01.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_01clasificador(evt);
            }
        });

        add(btn_01);
        btn_01.setBounds(690, 550, 200, 35);

        jPanel2.setLayout(null);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Estado", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        lbl_est.setForeground(new java.awt.Color(102, 102, 102));
        lbl_est.setText("OK");
        jPanel2.add(lbl_est);
        lbl_est.setBounds(10, 20, 560, 20);

        barra.setForeground(new java.awt.Color(204, 204, 204));
        jPanel2.add(barra);
        barra.setBounds(10, 20, 650, 20);

        add(jPanel2);
        jPanel2.setBounds(10, 540, 670, 50);

        jPanel5.setLayout(null);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Prepoda", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel5.setEnabled(false);
        jPanel5.setFont(new java.awt.Font("Dialog", 1, 12));
        lbl_3.setFont(new java.awt.Font("Dialog", 1, 14));
        lbl_3.setForeground(new java.awt.Color(102, 102, 102));
        lbl_3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lbl_3.setText("Cconfianza");
        lbl_3.setEnabled(false);
        jPanel5.add(lbl_3);
        lbl_3.setBounds(10, 20, 120, 20);

        jTextField1.setText("1");
        jTextField1.setEnabled(false);
        jPanel5.add(jTextField1);
        jTextField1.setBounds(150, 20, 50, 19);

        add(jPanel5);
        jPanel5.setBounds(10, 130, 260, 50);

        jPanel6.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "  ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Bitstream Vera Serif", 0, 12), new java.awt.Color(102, 102, 102)));
        jPanel6.setFont(new java.awt.Font("Dialog", 1, 12));
        jLabel3.setFont(new java.awt.Font("Bitstream Vera Serif", 1, 24));
        jLabel3.setForeground(new java.awt.Color(102, 102, 102));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setText("SLIQ");
        jPanel6.add(jLabel3);
        jLabel3.setBounds(90, 10, 80, 30);

        add(jPanel6);
        jPanel6.setBounds(10, 10, 260, 50);

    }// </editor-fold>//GEN-END:initComponents

    private void btn_01clasificador(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_01clasificador
        Thread sliq = new Thread(new Algoritmo_Sliq(),"hilo a");  
            sliq.start();
            iniciacuenta();
        if(ba==1){
                 JOptionPane.showMessageDialog(this,"El Algoritmo No Procesa Atributos Numericos!!"+'\n'+"Debe Discretizar en la Etapa de Preprocesamiento","SLIQ",JOptionPane.ERROR_MESSAGE);
        }else if(ba==2){
             JOptionPane.showMessageDialog(this,"ERROR: No Hay Conexion!!","SLIQ",JOptionPane.ERROR_MESSAGE);
        }else if (ba==3){
                 JOptionPane.showMessageDialog(this,"ERROR: En Proceso de Clasificacion!!!!","SLIQ",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btn_01clasificador

       
    private void lst_1evtpopup(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lst_1evtpopup
        int id;
        Vector aux = new Vector();
        if (!evt.isPopupTrigger() && SwingUtilities.isRightMouseButton(evt)){
            popup.show(evt.getComponent(),evt.getX(),evt.getY());
        } else{
            ren = null;
            super.processMouseEvent(evt);
            id = lst_1.getSelectedIndex();
            txta.setText(modelos.get(id).toString());            
        }
    }//GEN-LAST:event_lst_1evtpopup

    private void rbtn_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_3ActionPerformed
        txt_1.setEditable(false);
        txt_2.setEditable(true);
    }//GEN-LAST:event_rbtn_3ActionPerformed

    private void rbtn_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_2ActionPerformed
        txt_1.setEditable(true);
        txt_2.setEditable(false);
    }//GEN-LAST:event_rbtn_2ActionPerformed

    private void rbtn_1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtn_1ActionPerformed
        txt_1.setEditable(false);
        txt_2.setEditable(false);
    }//GEN-LAST:event_rbtn_1ActionPerformed
    
    public void iniciacuenta(){
        if( Sliq.hilo == null){
            Sliq.barra.setVisible(true);
            Sliq.hilo = new ThreadCarga2();
            Sliq.pideparar = false;
            Sliq.hilo.start();
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public static javax.swing.JPanel Pmod;
    public static javax.swing.JPanel Popc;
    public static javax.swing.JPanel Pred;
    public static javax.swing.JProgressBar barra;
    public static javax.swing.JButton btn_01;
    public static javax.swing.ButtonGroup buttonGroup1;
    public static javax.swing.JLabel jLabel1;
    public static javax.swing.JLabel jLabel2;
    public static javax.swing.JLabel jLabel3;
    public static javax.swing.JPanel jPanel1;
    public static javax.swing.JPanel jPanel2;
    public static javax.swing.JPanel jPanel5;
    public static javax.swing.JPanel jPanel6;
    public static javax.swing.JScrollPane jScrollPane1;
    public static javax.swing.JScrollPane jScrollPane2;
    public static javax.swing.JTextField jTextField1;
    public static javax.swing.JLabel lbl_02;
    public static javax.swing.JLabel lbl_3;
    public static javax.swing.JLabel lbl_est;
    public static javax.swing.JList lst_1;
    public static javax.swing.JRadioButton rbtn_1;
    public static javax.swing.JRadioButton rbtn_2;
    public static javax.swing.JRadioButton rbtn_3;
    public static javax.swing.JTextField txt_1;
    public static javax.swing.JTextField txt_2;
    public static javax.swing.JTextArea txta;
    // End of variables declaration//GEN-END:variables
    
}

 class Algoritmo_Sliq extends Thread{
    private double tiempo;
    /** Creates a new instance of Algoritmo_C45 */
    public Algoritmo_Sliq() {
        
    } 
     
     private void addarbol(){
	String sql;	
	String cad;        
        String nodo;       
        int tab = 0;        
        String padre ="";
        try{
             nodo = "1";             
             cad = "\n|\t";             
             ResultSet rs = null;
             do{
                 do{
                     sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase,com FROM sliq_nodes where nodo=" + nodo;
                     rs = Matekdd.CC.stm.executeQuery(sql);
                     while(rs.next()){                         
                        padre = rs.getString(2).toString();
                        if(rs.getString(2).equals("0")==true){
                         //   System.out.println("nodo 0");
                            cad = "\n";
                            tab = 1;                            
                            Sliq.ren += cad+"|-"+(rs.getString(3)) +rs.getString(8)+ (rs.getString(4))+"    "; 
                            while(rs.next()){
                                    Sliq.ren += " OR "+(rs.getString(3)) +rs.getString(8)+ (rs.getString(4))+"    ";                                                                
                            }
                            sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase FROM sliq_nodes where nodo=" + nodo;
                            rs = Matekdd.CC.stm.executeQuery(sql);
                            rs.next();
                            if(rs.getString(7).equals("-1")==false){
                                cad = cad + "|\t|- ";
                                cad += Sliq.lbl_02.getText() +" = "+ (rs.getString(7))+"    ";
                                Sliq.ren += cad;
                            }
                            nodo = rs.getString(5).toString();
                	}else{
                                tab++;
                                cad = "\n|";
                                for(int i=2; i<=tab; i++){
                                    cad += "\t|";
                                }                                                              
                                Sliq.ren += cad+"|-"+(rs.getString(3)) +rs.getString(8)+ (rs.getString(4))+"    ";                            
                                while(rs.next()){
                                     Sliq.ren += " OR "+(rs.getString(3)) +rs.getString(8)+ (rs.getString(4))+"    ";                            
                                }                            
                            sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase,com FROM sliq_nodes where nodo=" + nodo;
                            rs = Matekdd.CC.stm.executeQuery(sql);
                            rs.next();
                            nodo = rs.getString(5).toString();
                            if(rs.getString(7).equals("-1")==false){
                                    cad = cad + "|\t|- ";
                                    cad += Sliq.lbl_02.getText() +" = "+ (rs.getString(7))+"    ";
                                    Sliq.ren += cad;
                                }
                        }
                    
                        if(nodo.equals("-1")==true){
                            nodo = rs.getString(6).toString();
                            tab--;
                        }
                        
                        if(nodo.equals("-1")==false){
                            sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase,com FROM sliq_nodes where nodo=" + nodo;
                            rs = Matekdd.CC.stm.executeQuery(sql);
                        }                            
                     }     //while                                           
                 }while(nodo.equals("-1")==false);
                 
                 while(nodo.equals("-1")==true){                        
                     nodo = padre;
                     tab--;
                     if (nodo.equals("0")==false){
                        sql = "SELECT nodo,padre,atributo,valor,hijo,herm,clase,com FROM sliq_nodes where nodo=" + nodo;
                        rs = Matekdd.CC.stm.executeQuery(sql);
                        while(rs.next()){
                         nodo = rs.getString(6).toString();
                         padre = rs.getString(2).toString();
                        }
                     }                     
                 }
                 
             }while(nodo.equals("0")==false && nodo.equals("-1")==false);       
            rs.close();	
        }catch(Exception e){
            Sliq.ren += "\n NO SE PUDO MOSTRAR EL ARBOL!!";
            detienecuenta();
        }
      
    }
      
  private void iniciarren(){
        int n = new Integer(Seleccion.lbl_ins.getText());
        n = n - Sliq.Rpru;        
        Sliq.ren += "\n\t ===  .:. MODELO DE CLASIFICACION DEL ALGORITMO SLIQ .:.   ===";        
        Sliq.ren += "\n\n";
        Sliq.ren += "- TABLA: "+Seleccion.lbl_tabla.getText();
        Sliq.ren += "\n\n";
        Sliq.ren += "- INSTANCIAS: "+Seleccion.lbl_ins.getText();
        Sliq.ren += "\n\n";
        Sliq.ren += "- ATRIBUTOS: "+Seleccion.lbl_att.getText();
        Sliq.ren += "\n";
        Vector atts = new Vector();
        atts = Matekdd.CC.getcolumnname(Seleccion.lbl_tabla.getText());
        for(int i=0;i<atts.size();i++){
              Sliq.ren += "\n        "+(i+1)+"\t"+atts.elementAt(i);
        }
        Sliq.ren += "\n\n- CONJUNTO DE ENTRENAMIENTO: " + n;


        Sliq.ren += "\n\n\n\t ===  .:. ARBOL DE DECISION .:. ===";
        Sliq.ren += "\n";
    }
      
      public void preproceso_sliq(){
        int numR = 0;
        String sql;
        Double x;
        
        if(Sliq.rbtn_2.isSelected()){
            float por ;
            if( Integer.parseInt(Sliq.txt_1.getText())<101 && Integer.parseInt(Sliq.txt_1.getText())>0){
                numR = Integer.parseInt(Seleccion.lbl_ins.getText());
                por = new Float(Sliq.txt_1.getText()) / 100;
                numR = (int)(numR * por);                
            }
        }else if(Sliq.rbtn_3.isSelected()){
            if(Integer.parseInt(Sliq.txt_2.getText())<101 && Integer.parseInt(Sliq.txt_2.getText())>0){
                numR = Integer.parseInt(Sliq.txt_2.getText());                
            }
        }
        else{
            numR = Integer.parseInt(Seleccion.lbl_ins.getText());
        }
        try{
                Sliq.Rpru = numR;
                if (numR == Integer.parseInt(Seleccion.lbl_ins.getText())){
                    numR = 0;
                }
                sql = "SELECT * FROM trans_sliq('"+Preprocesamiento.lbl_tabla.getText()+"','"+Sliq.lbl_02.getText()+"',"+numR+")";
                Sliq.lbl_est.setText(sql);
                Matekdd.CC.Ejecutar(sql,2);
        }catch(Exception e){
                   //JOptionPane.showMessageDialog(Sliq.this,e.toString(),"SLIQ",JOptionPane.ERROR_MESSAGE);          
            Sliq.ba = 3;
            detienecuenta();
            
        }
 
    }

          
         public void run() {
            if(Matekdd.CC.db!=null){
            Matekdd.CC.cerrarBD();             
            Matekdd.CC.iniciarBD(frm_bd.txt_1.getText(),frm_bd.txt_2.getText(),new String(frm_bd.txt_3.getPassword()),frm_bd.txthost.getText(),frm_bd.spnPuerto.getValue().toString());
            Sliq.ren = new String();
            String sql = new String();       
            Sliq.lbl_est.setText("Clasificando con Sliq");
        int ban = 0;      

        iniciarren();
        try{
             double tmp = System.currentTimeMillis();
            preproceso_sliq();            
            long time = System.currentTimeMillis();
            sql = "SELECT * FROM sliq('"+Sliq.lbl_02.getText()+"')";
            Matekdd.CC.Ejecutar(sql,2);
            tiempo = (double)(System.currentTimeMillis() - time);           
            addarbol();            
            Sliq.ren += "\n\n\n\t === .:. RESULTADOS DE LA PRUEBA .:. ===\n\n";
            sql = "SELECT * FROM test_sliq('"+Sliq.lbl_02.getText()+"')";
            ResultSet rs = Matekdd.CC.stm.executeQuery(sql);
            while(rs.next()){
               if ("OK".equals(rs.getString(1).toString())){
                     ban = 1;
               }else{
                     if (ban == 0){
                         Sliq.ren += "\n";
                         Sliq.ren += rs.getString(1);
                     }else{
                         Sliq.ren += "\n\n";
                         Sliq.ren += "- CONJUNTO DE PRUEBA: "+ Sliq.Rpru;
                          String con = rs.getString(1);
                          int c = new Integer(con);
               
                          Sliq.ren +="\n\n- INSTANCIAS CORRECTAMENTE CLASIFICADAS: "+con+"     "+((c*100)/Sliq.Rpru)+" %" ;
   
                          Sliq.ren +="\n\n- INSTANCIAS INCORRECTAMENTE CLASIFICADAS: "+(Sliq.Rpru-c)+"     "+ ((Sliq.Rpru-c)*100/Sliq.Rpru)+" %";
                          
                     }
               }
           }
           rs.close();           
           tmp = (double)(System.currentTimeMillis()-tmp);            
           Sliq.ren += "\n\n";
           Sliq.ren +="TIEMPO: "+tiempo/1000+" Sg. - Creacion del Modelo";               
           Sliq.ccm ++;
           sql = "CREATE TABLE sliq"+Preprocesamiento.lbl_tabla.getText()+Sliq.ccm+" AS SELECT * FROM sliq_nodes";                       
           Matekdd.CC.Ejecutar(sql,2);        
           Sliq.mod.addElement("sliq"+Preprocesamiento.lbl_tabla.getText()+Sliq.ccm);
           sql = "DROP TABLE sliq_rules";
           Matekdd.CC.Ejecutar(sql,2);
           sql = "DROP TABLE sliq_nodes";
           Matekdd.CC.Ejecutar(sql,2);
           Sliq.lbl_est.setText("Termino Sliq OK ("+tmp/1000+" Sg.");         
           detienecuenta();
        }catch(Exception e){
            //JOptionPane.showMessageDialog(Sliq.this,e.toString(),"SLIQ",JOptionPane.ERROR_MESSAGE);          
            Sliq.ba=3;
            detienecuenta();
        }
            Sliq.lst_1.setListData(Sliq.mod);
            Sliq.txta.setText(Sliq.ren);
            Sliq.modelos.add(Sliq.ren);     
        }else{
          //  JOptionPane.showMessageDialog(this,"ERROR: No Hay Conexion !!","SLIQ",JOptionPane.ERROR_MESSAGE);
                 Sliq.ba=3;
                 detienecuenta();
        }

    }

         
         public void detienecuenta(){
             synchronized(Sliq.objeto)
             {
                 Sliq.barra.setVisible(false);
                 Sliq.pideparar = true;
                 Sliq.objeto.notify();
                 Sliq.hilo=null;
             }}
}

  
   class ThreadCarga2 extends Thread {
       public void run() {
           int min = 0;
           int max = 100;
           
           Sliq.barra.setValue(min);
           Sliq.barra.setMinimum(min);
           Sliq.barra.setMaximum(max);        
                   
           for( int i=min; i<= max; i=i+10){
               
               Sliq.barra.setValue(i);
               synchronized( Sliq.objeto ){
                   if (Sliq.pideparar)
                    break;
                   try {
                       Sliq.objeto.wait(100);
                       
                   } catch(InterruptedException e){
                       //se ignoran las ex
                   }
                    if (i==100) i=min;
               }
           }                   
       }
   }
