/*
 * Functionplpgsql.java
 *
 * Created on August 7, 2016, 4:20 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package paquetes;

import Iprincipal.Matekdd;
import java.io.File;
import java.io.FileInputStream;
import java.sql.ResultSet;
import javax.swing.JOptionPane;

/**
 *
 * @author root
 */
public class Functionplpgsql {
    
    /** Creates a new instance of Functionplpgsql */
    public Functionplpgsql() {
        Matekdd.CC.Ejecutar("CREATE FUNCTION plpgsql_call_handler() RETURNS OPAQUE AS '/usr/local/pgsql/lib/plpgsql.so' LANGUAGE 'c'",2);
        Matekdd.CC.Ejecutar("CREATE TRUSTED PROCEDURAL LANGUAGE 'plpgsql' HANDLER plpgsql_call_handler LANCOMPILER 'pl/pgSQL'",2);        
    }
   
    public String FuncionesSql(){        
        
        String rta = crearF("/opt/Matekdd/functions/Preprocess/","process_add.sql");
        rta = crearF("/opt/Matekdd/functions/Preprocess/","process_del.sql");
        rta = crearF("/opt/Matekdd/functions/Preprocess/","process_dtz.sql");
        rta = crearF("/opt/Matekdd/functions/Preprocess/","process_fcd.sql");
        rta = crearF("/opt/Matekdd/functions/Preprocess/","process_nlz.sql");
        rta = crearF("/opt/Matekdd/functions/Preprocess/","process_rdm.sql");
        
        rta = crearF("/opt/Matekdd/functions/AlgorithmC45/","c45_algorithm.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmC45/","c45_entro.sql");       
        rta = crearF("/opt/Matekdd/functions/AlgorithmC45/","c45_gain.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmC45/","c45_tree.sql");
        
        rta = crearF("/opt/Matekdd/functions/AlgorithmMate/","mate_gain.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmMate/","mate_tree.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmMate/","mateby.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmMate/","matetree.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmMate/","posiciones.sql");
        
        rta = crearF("/opt/Matekdd/functions/AlgorithmSliq/","sliq_algorithm.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmSliq/","sliq_gini.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmSliq/","sliq_tree.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmSliq/","sliq_combinar.sql");
        rta = crearF("/opt/Matekdd/functions/AlgorithmSliq/","sliq_set.sql");
    
        rta = crearF("/opt/Matekdd/functions/Transform/","filter.sql");
        rta = crearF("/opt/Matekdd/functions/Transform/","purify.sql");
        rta = crearF("/opt/Matekdd/functions/Transform/","trans_c45_mate.sql");
        rta = crearF("/opt/Matekdd/functions/Transform/","trans_sliq.sql");
        rta = crearF("/opt/Matekdd/functions/Transform/","transform.sql");
         rta = crearF("/opt/Matekdd/functions/Transform/","view_set.sql");
        
        rta = crearF("/opt/Matekdd/functions/Valid/","test_rules.sql");
        rta = crearF("/opt/Matekdd/functions/Valid/","arm_rules.sql");
        rta = crearF("/opt/Matekdd/functions/Valid/","test_sliq.sql");
        rta = crearF("/opt/Matekdd/functions/Valid/","translate_rules.sql");
        rta = crearF("/opt/Matekdd/functions/Valid/","translate_inte.sql");
        rta = crearF("/opt/Matekdd/functions/Valid/","save_tree.sql");
         rta = crearF("/opt/Matekdd/functions/Valid/","interprete.sql");
        
        return null;
    }
    
    private String crearF(String dir,String arc){
    String rta = null;    
    try{            
            File fichentrada = new File(dir+File.separatorChar+arc);
            FileInputStream canalEntrada = new FileInputStream(fichentrada);
        
            byte bt[] = new byte[(int)fichentrada.length()];
            int numBytes = canalEntrada.read(bt);
            String cadena = new String(bt);
            StringBuffer sql = new StringBuffer(cadena);
            //System.out.println(sql);
            Matekdd.CC.Ejecutar(new String(sql),2);       
            //System.out.println("Ejecuta "+arc);
            rta = "ok";
            canalEntrada.close();            
        }catch(Exception e){              
            System.out.println("Error no se crea "+e.toString());
        }
    return rta;        
    }
     
        
    
}


