package paquetes;
/*
 * createTreeGUI.java
 *
 * Created on 30 de agosto de 2016, 11:16 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * 
 */
import Iprincipal.C45;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import paquetes.createTree;
import paquetes.Tree;

/**
 *
 * @author Tariy
 */

/*Interfaz grafica que muestra el contenido de Tree usa dos botones, un panel y
 *el JTree que extendimos
 */ 
public class createTreeGUI extends JPanel {
    public static Tree tree;
    /** Creates a new instance of TariyNTreeGUI */
    public createTreeGUI(Tree tree) {
        super(new BorderLayout());
        
        // Construct the button panel and the buttons.
        JPanel panel = new JPanel();
        JButton btnExpand = new JButton("Expandir Todo");
        JButton btnCollapse = new JButton("Contraer Todo");
        panel.add(btnExpand);
        panel.add(btnCollapse);
        
        // Construct the tree.
        this.tree = tree;
        tree.setFont(C45.txta.getFont());
        JScrollPane scrollPane = new JScrollPane(tree);
        scrollPane.setPreferredSize(new Dimension(300, 400));
        
        // Add everything to this panel.
        add(panel, BorderLayout.NORTH);
        add(scrollPane, BorderLayout.CENTER);
        
        // Control the buttons events.
        btnExpand.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                createTreeGUI.this.expandRows();
            }
        });
        
        btnCollapse.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                createTreeGUI.this.collapseRows();
            }
        });
    }
    
    public static void expandRows() {
        int row = 0;
        while(row < tree.getRowCount()) {
            tree.expandRow(row);
            row++;
        }
    }
    
    public static void collapseRows() {
        int row = tree.getRowCount();
        while(row > 0) {
            tree.collapseRow(row);
            row--;
        }
    }
    
   public static void createAndShowGUI(Tree tree, String name) {
        // Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);
        
        // Create and set up the window.
        JFrame frame = new JFrame("ARBOL DE DECISION DE "+name);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        
        // Create and set up the content pane.
        createTreeGUI contentPane = new createTreeGUI(tree);
        contentPane.setOpaque(true); // Content pane must be opaque.
        frame.setContentPane(contentPane);
        
        // Display the window.
        frame.pack();
        frame.setVisible(true);
        frame.setLocation(350,140);
        createTreeGUI.expandRows();
        createTreeGUI.collapseRows();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // Schedule a job for the event-dispatching thread:
        // creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI(new Tree(new createTree("Funciona!!!")),"");
            }
        });
    }
}
