CREATE OR REPLACE FUNCTION sliq_gini(varchar) RETURNS SETOF varchar AS' --clase
DECLARE
	cona		integer;
	numclas		integer;
	concla		integer;
	bclas		integer;	
	i		integer;
	oid		integer;
	ban		integer;
		
	Gan		float;
	Gan_may		float DEFAULT 0;
	div		float;
	naux		float;
	nant		float;
		
	attri		text DEFAULT NULL;
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	sql11		text DEFAULT '''';
	sql2		text DEFAULT '''';		
	prueba		text DEFAULT NULL;
	cad		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;
	rec3		record;
	rec4		record;
	rec5		record;
	
BEGIN
	sql := ''SELECT attnum, attname, relnatts, atttypid FROM pg_class, pg_attribute''
		|| '' WHERE pg_class.relname = ''''viewsliq'''' AND attname!=''''''||$1||''''''''
		||'' AND pg_attribute.attrelid = pg_class.oid AND attnum > 0 ORDER BY attnum'';
		
	bclas := 0;
	prueba := ''no'';
	numclas := 1;
	
	FOR rec1 IN EXECUTE sql LOOP 
	
		attri := rec1.attname;
			
--******************ATRIBUTO NUMERICO******************

		IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 700 OR rec1.atttypid = 1700 OR rec1.atttypid = 701 THEN 

 			sql2 := ''SELECT ''||attri||'' AS at FROM viewsliq GROUP BY ''||attri||'' ORDER BY ''||attri;
			
			nant := NULL;
			FOR rec2 IN EXECUTE sql2 LOOP --selecciona valores ordenados
				
				IF nant ISNULL THEN
					nant := CAST(rec2.at as float);
					naux := CAST(rec2.at as float);
				ELSE
					nant := naux;
					naux := CAST(rec2.at as float);
					div := nant + ((naux - nant)/2);
					
					sql1 := ''SELECT COUNT(*) AS ct FROM viewsliq WHERE ''
						||attri||'' <=''||div || '' GROUP BY ''||$1;	
					
						
--****************************AQUI ANALISAMOS LA E A UNA CLASE ******************
					
					
					concla := 0;
					
					FOR rec3 IN EXECUTE sql1 LOOP	
						concla := concla + 1;
					END LOOP;
					
					IF concla = 1 THEN
						IF rec3.ct > 1 AND rec3.ct > numclas THEN
							bclas := 1;
							numclas := rec3.ct;
							prueba := ''ok'';
							EXECUTE ''DELETE FROM sliq_cond'';
							EXECUTE ''INSERT INTO sliq_cond VALUES (''''''
								||attri||'''''',''''''||CAST(div as numeric)||'''''',1)'';
						END IF;
					END IF;
						
					sql11 := ''SELECT COUNT(*) AS ct FROM viewsliq WHERE ''||attri
						||''>''||div|| '' GROUP BY ''||$1;
						
					concla := 0;
					FOR rec3 IN EXECUTE sql11 LOOP
						concla := concla + 1;
					END LOOP;
						
					IF concla = 1 THEN
						IF rec3.ct > numclas THEN
							bclas := 1;	
							numclas := rec3.ct;
							prueba := ''ok'';
							EXECUTE ''DELETE FROM sliq_cond'';
							EXECUTE ''INSERT INTO sliq_cond VALUES (''''''
								||attri||'''''',''''''||CAST(div as numeric)||'''''',1)'';
						END IF;
					END IF;
							
					IF bclas = 0 THEN

--***************AQUI CALCULAMOS LA GANANCIA*********************

						FOR rec3 IN EXECUTE sql1 LOOP
						END LOOP;
						cona := rec3.ct;
							
						Gan := 0;
						
						FOR rec3 IN EXECUTE sql1 LOOP	
							Gan := Gan + ((rec3.ct/cona)*(rec3.ct/cona));	
						END LOOP;
						
						Gan := 1 - Gan;
						
						IF Gan > Gan_may THEN	
							Gan_may := Gan;	
							prueba := ''ok'';
							EXECUTE ''DELETE FROM sliq_cond'';
							EXECUTE ''INSERT INTO sliq_cond VALUES (''''''
								||attri||'''''',''''''
								||CAST(div as numeric)||'''''',1)'';
						END IF;
					END IF;
				END IF;	
			
			END LOOP;

--*********************************ATRIBUTO CATEGORICO**************************************
		ELSE
			ban := 0;
			FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname=''''sliq_val'''''' LOOP
				EXECUTE ''DROP TABLE sliq_val'';		
			END LOOP;			
			sql2 := null;
			sql1 := null;
			
			FOR rec1 IN EXECUTE ''SELECT DISTINCT ''||attri||'' AS vl FROM viewsliq'' LOOP
				IF sql2 ISNULL THEN
					sql2 := ''CREATE TABLE sliq_val(''||rec1.vl||'' bpchar'';
					sql1 := ''INSERT INTO sliq_val VALUES(''''''||rec1.vl
						||'''''''';	
				ELSE
					sql2 := sql2 || '',''||rec1.vl||'' bpchar'';
					sql1 := sql1||'',''''''||rec1.vl||'''''''';	
				END IF;				
				ban := ban + 1;
				
			END LOOP;
			
			sql2 := sql2 || '')'';
			sql1 := sql1 || '')'';
		--RAISE NOTICE ''%'',sql2;
			IF ban > 1 THEN				
				EXECUTE sql2;
				EXECUTE sql1;				
				EXECUTE ''SELECT * FROM sliq_combinar()'';	
				
				FOR rec3 IN EXECUTE ''SELECT oid FROM sliq_cmb'' LOOP
					cad := null;
					oid := rec3.oid;
					FOR rec2 IN EXECUTE ''SELECT DISTINCT ''||attri||'' AS at FROM viewsliq '' LOOP 
						FOR rec4 IN EXECUTE ''SELECT ''||rec2.at||'' AS v FROM sliq_cmb WHERE oid=''||rec3.oid LOOP
						
							IF cad ISNULL THEN
								IF rec4.v IS NOT NULL THEN
									cad := attri ||''=''''''||rec4.v||'''''''';
								END IF;
							ELSE
								IF rec4.v IS NOT NULL THEN
									cad := cad ||''  OR ''||attri ||''=''''''||rec4.v||'''''''';
								END IF;
							END IF;
						END LOOP;
						
					END LOOP;	
					
--*****************AQUI ANALISAMOS LA E A UNA CLASE***********************
		
					sql11 := ''SELECT COUNT(*) AS ct FROM viewsliq WHERE ''||cad||'' GROUP BY ''||$1;					
					concla := 0;
						
					FOR rec2 IN EXECUTE sql11 LOOP	
						concla := concla + 1;
					END LOOP;	
						
					IF concla = 1 THEN				
						IF rec2.ct > numclas THEN
							bclas := 1;						
							numclas := rec2.ct;
							prueba := ''ok'';
							EXECUTE ''DELETE FROM sliq_cond'';
							FOR rec2 IN EXECUTE ''SELECT DISTINCT ''||attri||'' AS at FROM viewsliq '' LOOP 
								FOR rec5 IN EXECUTE ''SELECT ''||rec2.at||'' AS v FROM sliq_cmb WHERE oid=''||oid LOOP
									IF rec5.v IS NOT NULL THEN
										EXECUTE ''INSERT INTO sliq_cond VALUES (''''''||attri
										||'''''',''''''||rec5.v
										||'''''',2)'';
									END IF;		
								END LOOP;
							END LOOP;
						END IF;
					END IF;	
		
--**AQUI CALCULAMOS LA GANANCIA
					IF bclas = 0 THEN
						sql1 := ''SELECT COUNT(*) AS ct FROM viewsliq WHERE ''||cad;
						FOR rec2 IN EXECUTE sql1 LOOP
						END LOOP;
						cona := CAST(rec2.ct as float);
									
						Gan := 0;
						sql11 := sql1 || '' GROUP BY ''||$1;
								
						FOR rec2 IN EXECUTE sql11 LOOP
							nant := CAST(rec2.ct as float);
							naux := nant/cona;
							Gan := Gan + ((CAST(nant/cona as float))*(CAST(nant/cona as float)));
						END LOOP;
							
						Gan := 1 - Gan;				
						IF Gan > Gan_may AND bclas = 0 THEN
							Gan_may := Gan;
							EXECUTE ''DELETE FROM sliq_cond'';
					
							FOR rec2 IN EXECUTE ''SELECT DISTINCT ''||attri||'' AS at FROM viewsliq '' LOOP 
								FOR rec5 IN EXECUTE ''SELECT ''||rec2.at||'' AS v FROM sliq_cmb WHERE oid=''||oid LOOP
									IF rec5.v IS NOT NULL THEN
										EXECUTE ''INSERT INTO sliq_cond VALUES (''''''||attri
											||'''''',''''''
											||rec5.v||'''''',2)'';
									END IF;			
								END LOOP;
							END LOOP;
							prueba := ''ok'';	
						END IF;
					END IF;
				END LOOP;						
				EXECUTE ''DROP TABLE sliq_cmb'';	
			END IF;
		END IF;	
	END LOOP;

--**SE INSERTA EN PG_COL	
	
	IF prueba = ''ok'' THEN		
		FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
		 cona := rec1.mx + 1;
		END LOOP;
		i := 1;
		FOR rec1 IN EXECUTE ''SELECT * FROM sliq_cond'' LOOP
			IF i = 1 THEN				
				IF rec1.tipo = 1 THEN					
					EXECUTE ''INSERT INTO pg_col VALUES(''||cona||'',1,''''''||rec1.att
					||'''''',''''''||rec1.valor||'''''',''''<='''',''||rec1.tipo||'')'';
				ELSE
					EXECUTE ''INSERT INTO pg_col VALUES(''||cona||'',1,''''''
					||CAST(rec1.att as bpchar)||'''''',''''''||rec1.valor
					||'''''',''''='''',''||rec1.tipo||'')'';
				END IF;
				i := 0;
			ELSE
				IF rec1.tipo = 1 THEN					
					EXECUTE ''INSERT INTO pg_col VALUES(''||cona||'',2,''''''||rec1.att||'''''',''''''
					||rec1.valor||'''''',''''<='''',''||rec1.tipo||'')'';
				ELSE
					EXECUTE ''INSERT INTO pg_col VALUES(''||cona||'',2,''''''
					||CAST(rec1.att as bpchar)||'''''',''''''||rec1.valor
					||'''''',''''='''',''||rec1.tipo||'')'';
				END IF;
			END IF;			
		END LOOP;
	END IF;	

	RETURN NEXT prueba;
	
	RETURN;
	
END;'
LANGUAGE 'plpgsql' WITH (isstrict);