CREATE OR REPLACE FUNCTION sliq_set() RETURNS SETOF varchar AS'--CLASE
DECLARE
		
	condicion	text DEFAULT NULL;
	rec1		record;		
	sql		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	
BEGIN
	FOR rec1 IN EXECUTE ''SELECT DISTINCT att FROM pg_col WHERE n!=0 AND tipo=1'' LOOP
		IF sql IS NULL THEN
			sql := ''attname !=''''''||rec1.att||'''''''';
		ELSE
			sql := sql ||'' AND attname !=''''''||rec1.att||'''''''';
		END IF;
	END LOOP;
	
	IF sql IS NOT NULL THEN
		sql := ''SELECT attnum, attname, relnatts, atttypid FROM pg_class, pg_attribute''
			|| '' WHERE pg_class.relname = ''''kdd_ent'''' AND pg_attribute.attrelid = pg_class.oid''
			||'' AND ''|| sql || '' AND attnum > 0 ORDER BY attnum'';
		
		
		FOR rec1 IN EXECUTE sql LOOP
			IF cad IS NULL THEN
				cad := rec1.attname;
			ELSE
				cad := cad ||'',''||rec1.attname;
			END IF;
		END LOOP;
	END IF;	
	condicion := NULL;
	FOR rec1 IN EXECUTE ''SELECT id,att,valor,com,tipo FROM pg_col WHERE n!=0'' LOOP
			
		IF condicion ISNULL THEN
			
			IF rec1.tipo = 1 THEN   --**2=categorico 1=float
				condicion := ''(''||CAST(rec1.att as varchar) 
				||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar);
				
			ELSE	
				condicion := ''(''||rec1.att||CAST(rec1.com as varchar)||''''''''
					||CAST(rec1.valor as varchar)||'''''''';
			END IF;
				
		ELSE
			IF rec1.tipo = 1 THEN   --**2=categorico 1=floato
				
				IF rec1.id = 2 THEN
					condicion := condicion||'' OR ''||rec1.att ||rec1.com||rec1.valor;
				ELSE
					condicion := condicion||'') AND (''||rec1.att ||rec1.com
							||rec1.valor;
				END IF;
			ELSE	
				IF rec1.id = 2 THEN
					IF rec1.com = ''='' THEN
						condicion := condicion||'' OR ''
						||CAST(rec1.att as varchar)
						||CAST(rec1.com as varchar)||''''''''
						||CAST(rec1.valor as varchar)||'''''''';
					ELSE
						condicion := condicion||'' AND ''
						||CAST(rec1.att as varchar)
						||CAST(rec1.com as varchar)||''''''''
						||CAST(rec1.valor as varchar)||'''''''';
					END IF;
				ELSE
					condicion := condicion||'') AND (''
					||CAST(rec1.att as varchar)
					||CAST(rec1.com as varchar)||''''''''
					||CAST(rec1.valor as varchar)||'''''''';
				END IF;				
			END IF;
		END IF;
	END LOOP;
	condicion := condicion ||'')'';
--  	RAISE NOTICE ''condicion %'',condicion;
	EXECUTE ''DROP VIEW viewsliq'';
	IF sql IS NOT NULL THEN
		EXECUTE ''CREATE VIEW viewsliq AS SELECT ''||cad||'' FROM kdd_ent WHERE ''||condicion;
	ELSE
		EXECUTE ''CREATE VIEW viewsliq AS SELECT * FROM kdd_ent WHERE ''||condicion;
	END IF;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);