CREATE OR REPLACE FUNCTION sliq_tree(VARCHAR,INTEGER) RETURNS SETOF varchar AS'--CLASE
DECLARE
		
	bclas		integer;
	con		integer;
	cona		integer;
	ipg		integer;
		
	Gan		float;
	Gan_may		float;
	div		float;
	naux		float;
	nant		float;
	
	attgan		text DEFAULT NULL;
	clase		text DEFAULT NULL;
	attganv		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	sql2		text DEFAULT '''';
	atributos	text DEFAULT NULL;
	condicion	text DEFAULT NULL;
	prueba		text DEFAULT NULL;
	aux		varchar;
			
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN
	
	EXECUTE ''SELECT * FROM sliq_set()'';
	
	FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
	END LOOP;
	
	ipg := rec1.mx;	
	IF $2 = 1 THEN
--**AGREGA NODO

		FOR rec1 IN EXECUTE ''SELECT MAX(nodo) AS cc FROM sliq_nodes'' LOOP
			con := rec1.cc + 1;
		END LOOP;
			
		sql2 := ''SELECT id,att,valor,com FROM pg_col WHERE n=''||ipg;			
		
		FOR rec2 IN EXECUTE sql2 LOOP
		
			IF rec2.com = ''<='' OR rec2.com = ''='' THEN
			
				sql2 := ''SELECT att,valor,com FROM pg_col WHERE n=''||(ipg-1);
				
				FOR rec1 IN EXECUTE sql2 LOOP
				END LOOP;
					
				sql1 := ''SELECT nodo FROM sliq_nodes WHERE atributo=''''''
					||CAST(rec1.att as varchar)||'''''' AND valor=''''''
					||CAST(rec1.valor as varchar) ||'''''''';
					
				FOR rec3 IN EXECUTE sql1 LOOP
					IF rec1.com = ''<='' OR rec1.com = ''='' THEN --IZQUIERDA
					sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''
						||rec3.nodo||'',1,''||''''''''||rec2.att||'''''',''
						||''''''''||rec2.valor||'''''',''''''||rec2.com||'''''')'';
								
				ELSE -- DERECHA
						
					sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''||rec3.nodo
						||'',2,''||''''''''||rec2.att||'''''',''||''''''''||rec2.valor
						||'''''',''''''||rec2.com||'''''')'';
						
				END IF;
				END LOOP;
				EXECUTE sql1;
			END IF;
		END LOOP;
	END IF;

--***************VALIDAR QUE LOS ATRIBUTOS PERTENESCAN A LA MISMA CLASE******************
	
	sql1 := ''SELECT COUNT(*) AS cc,''||$1||'' AS at FROM viewsliq GROUP BY ''||$1;	
	cona := 0;	
	FOR rec1 IN EXECUTE sql1 LOOP
		cona := cona + 1;
		clase := rec1.at;
	END LOOP;
	
	IF cona = 1 THEN  --PERTENECEN A LA MISMA CLASE	
		
--**AGREGAR REGLA 
		cona := null;
		FOR rec2 IN EXECUTE ''SELECT MAX(n) AS mx FROM sliq_rules'' LOOP
			cona := rec2.mx + 1;
		END LOOP;
		
		IF cona IS NULL THEN
			cona := 1;
		END IF;
		
		FOR rec1 IN EXECUTE ''SELECT id,att,valor,com,tipo FROM pg_col WHERE n!=0'' LOOP
			sql2 := ''INSERT INTO sliq_rules VALUES(''||cona||'',''||rec1.id||'',''''''
				||rec1.att||'''''',''''''||rec1.valor||'''''',''''''||rec1.com
				||'''''',''||rec1.tipo||'')'';
			EXECUTE sql2;
			
		END LOOP;
		
		sql2 := ''INSERT INTO sliq_rules VALUES(''||cona||'',1,''''''||$1
			||'''''',''''''||clase||'''''',''''='''',2)'';
		
		EXECUTE sql2;
		
--**AGREGAR NODO DE LA CLASE
		
		con := con + 1;
		FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
		END LOOP;
		
		sql2 := ''SELECT att,valor,com,tipo FROM pg_col WHERE n=''||rec1.mx;	
		ipg := rec1.mx;
		
		FOR rec2 IN EXECUTE sql2 LOOP
		END LOOP;
		
		FOR rec1 IN EXECUTE ''SELECT MAX(nodo) AS cc FROM sliq_nodes'' LOOP
			con := rec1.cc + 1;
		END LOOP;
		
		sql1 := ''SELECT nodo FROM sliq_nodes WHERE atributo=''''''
			||CAST(rec2.att as varchar)||'''''' AND valor=''''''
			||CAST(rec2.valor as varchar) ||'''''''';
		
		FOR rec1 IN EXECUTE sql1 LOOP
			IF rec2.com = ''<='' OR rec2.com = ''='' THEN --IZQUIERDA
				sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''||rec1.nodo||'',1,''
				||''''''''||$1||'''''',''||''''''''||clase||'''''',''''='''')'';
						
			ELSE -- > DERECHA
				
				sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''||rec1.nodo||'',2,''
				||''''''''||$1||'''''',''||''''''''||clase||'''''',''''='''')'';
				
			END IF;
		END LOOP;	
		EXECUTE sql1;
			
--**CAMBIAR CONDICION O BORRAR ATRIBUTO DE pg_col

		IF rec2.tipo = 1 THEN --NUMERICO
			
			IF rec2.com = ''<='' THEN --IZQUIERDA
				EXECUTE ''UPDATE pg_col SET com=''''>'''' WHERE n=''||ipg;
				EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
				bclas := 1;
					
			ELSE -- > DERECHA
				EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
				bclas := 0;	
			
			END IF;
				
		ELSE --CATEGORICO
			
			IF rec2.com = ''='' THEN --IZQUIERDA
				EXECUTE ''UPDATE pg_col SET com=''''!='''' WHERE n=''||ipg;
				EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
				bclas := 1;
				
			ELSE -- != DERECHA
				EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
				bclas := 0;
				
			END IF;
			
		END IF;
			
		FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
		END LOOP;
		ipg := rec1.mx;
					
		WHILE bclas = 0 AND ipg <> 0 LOOP
						
			sql2 := ''SELECT com,tipo FROM pg_col WHERE n=''||ipg;
			FOR rec1 IN EXECUTE sql2 LOOP
			END LOOP;
						
			IF rec1.tipo = 1 THEN --NUMERICO
				
				IF rec1.com = ''<='' THEN --IZQUIERDA
					EXECUTE ''UPDATE pg_col SET com=''''>'''' WHERE n=''||ipg;
					EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
					bclas := 1;
					
				ELSE -- > DERECHA
					EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;
				END IF;
								
			ELSE --CATEGORICO
			
				IF rec1.com = ''='' THEN --IZQUIERDA
					EXECUTE ''UPDATE pg_col SET com=''''!='''' WHERE n=''||ipg;
					EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
					bclas := 1;
								
				ELSE -- != DERECHA
					EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
			
				END IF;	
			END IF;
						
			FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
			END LOOP;
			ipg := rec1.mx;
						
		END LOOP;
					
	ELSE 

--**NO PERTENECEN A LA MISMA CLASE
		
		FOR rec1 IN EXECUTE ''SELECT * FROM sliq_gini(''''''||$1||'''''')'' LOOP
		END LOOP;	

		IF rec1.sliq_gini = ''ok'' THEN
				
			EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',1)'';
			bclas := 1;
		ELSE
			bclas := 0;
		END IF;	
		
	
	END IF;	
	
	IF bclas = 0 AND ipg <> 0 THEN --NO HAY MAS ATRIBUTOS Y QUEDA LA REGLA SIN CONCLUIR O SEA NULL
		
		FOR rec2 IN EXECUTE ''SELECT MAX(n) AS mx FROM sliq_rules'' LOOP
			cona := rec2.mx + 1;
		END LOOP;
		
		IF cona IS NULL THEN
			cona := 1;
		END IF;
		
		FOR rec1 IN EXECUTE ''SELECT id,att,valor,com,tipo FROM pg_col WHERE n!=0'' LOOP
			
			sql2 := ''INSERT INTO sliq_rules VALUES(''||cona||'',''||rec1.id||'',''''''
				||rec1.att||'''''',''''''||rec1.valor||'''''',''''''||rec1.com
				||'''''',''||rec1.tipo||'')'';

			EXECUTE sql2;
			
		END LOOP;
		
		sql2 := ''INSERT INTO sliq_rules VALUES(''||cona||'',1,''''''||$1
			||'''''','''''''',''''='''',2)'';
			
		EXECUTE sql2;	
			
		FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
		END LOOP;
		ipg := rec1.mx;
		
		IF rec1.mx <> 0 THEN 
		
			FOR rec1 IN EXECUTE ''SELECT MAX(nodo) AS cc FROM sliq_nodes'' LOOP
				con := rec1.cc + 1;
			END LOOP;	
		
			sql2 := ''SELECT att,valor,com,tipo FROM pg_col WHERE n=''||ipg;
				
			FOR rec2 IN EXECUTE sql2 LOOP
			END LOOP;
			
			sql1 := ''SELECT nodo FROM sliq_nodes WHERE atributo=''''''||rec2.att
				||'''''' AND valor=''''''||CAST(rec2.valor as varchar)||'''''''';
				RAISE NOTICE ''%'',sql1;
			FOR rec1 IN EXECUTE sql1 LOOP
				IF rec2.com = ''<='' OR rec2.com = ''='' THEN --IZQUIERDA
					sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''||rec1.nodo
						||'',1,''||''''''''||$1||'''''','''''''',''''='''')'';
								
				ELSE -- > DERECHA
					sql1 := ''INSERT INTO sliq_nodes VALUES(''||con||'',''||rec1.nodo
						||'',2,''||''''''''||$1||'''''','''''''',''''='''')'';
						
				END IF;	
			END LOOP;
			EXECUTE sql1;
		END IF;
		
--**CAMBIAR CONDICION O BORRAR ATRIBUTO DE pg_col

		sql2 := ''SELECT att,valor,com,tipo FROM pg_col WHERE n=''||ipg;			
		
		FOR rec2 IN EXECUTE sql2 LOOP
		END LOOP;

		IF rec2.tipo = 1 THEN --NUMERICO
			
			IF rec2.com = ''<='' THEN --IZQUIERDA
				EXECUTE ''UPDATE pg_col SET com=''''>'''' WHERE n=''||ipg;
				EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
				bclas := 1;
					
			ELSE -- > DERECHA
				EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
				bclas := 0;	
			
			END IF;
				
		ELSE --CATEGORICO
			
			IF rec2.com = ''='' THEN --IZQUIERDA
				EXECUTE ''UPDATE pg_col SET com=''''!='''' WHERE n=''||ipg;
				EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
				bclas := 1;
				
			ELSE -- != DERECHA
				EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
				bclas := 0;
				
			END IF;
			
		END IF;
			
		FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
		END LOOP;
		ipg := rec1.mx;
					
		WHILE bclas = 0 AND ipg <> 0 LOOP
						
			sql2 := ''SELECT com,tipo FROM pg_col WHERE n=''||ipg;
			FOR rec1 IN EXECUTE sql2 LOOP
			END LOOP;
						
			IF rec1.tipo = 1 THEN --NUMERICO
				
				IF rec1.com = ''<='' THEN --IZQUIERDA
					EXECUTE ''UPDATE pg_col SET com=''''>'''' WHERE n=''||ipg;
					EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
					bclas := 1;
					
				ELSE -- > DERECHA
					EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;
				END IF;
								
			ELSE --CATEGORICO
			
				IF rec1.com = ''='' THEN --IZQUIERDA
					EXECUTE ''UPDATE pg_col SET com=''''!='''' WHERE n=''||ipg;
					EXECUTE ''SELECT * FROM sliq_tree(''''''||$1||'''''',0)'';
					bclas := 1;
								
				ELSE -- != DERECHA
					EXECUTE ''DELETE FROM pg_col WHERE n=''||ipg;	
			
				END IF;	
			END IF;
						
			FOR rec1 IN EXECUTE ''SELECT MAX(n) AS mx FROM pg_col'' LOOP
			END LOOP;
			ipg := rec1.mx;
						
		END LOOP;
			
	END IF;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);