CREATE OR REPLACE FUNCTION process_nlz(varchar,int) RETURNS SETOF varchar AS '
/* Funcion que normaliza una tabla o un atributo, recibe como parametro el nombre de la tabla y 
 * el numero del atributo a normalizar si este nuemro es iguakl a 0 se normalizar toda la tabla, sino 
 * el atributo indicado
*/
DECLARE
	
	i		integer;
	cont		integer;
	max		numeric(10,3);

	
	var		numeric(10,3);
	
	sql		text DEFAULT '''';
	sql2		text DEFAULT '''';
	cad		text DEFAULT NULL;
	tabla		text DEFAULT NULL;
		
	rec1		record;	
	rec2		record;	
	oid		integer;
	
	flag_val	text;
	
BEGIN

--****	CREA TABLA tablan


	sql := ''SELECT attnum,attname,atttypid,typname FROM pg_class, pg_attribute,pg_type''
		|| '' WHERE pg_class.relname = ''''''||$1||''''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND pg_type.oid=pg_attribute.atttypid AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF cad ISNULL THEN
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 THEN
			   IF $2 = 0 THEN
			   cad := rec1.attname||'' numeric(10,3)'';
			   ELSE
			   	IF $2 = rec1.attnum THEN
					cad := rec1.attname||'' numeric(10,3)'';
				ELSE
			   		cad := rec1.attname||'' ''||rec1.typname;
				END IF;
			   END IF;
			ELSE
			   cad := rec1.attname||'' ''||rec1.typname;
			END IF;	
		ELSE	
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 THEN
			   IF $2 = 0 THEN
			   	cad := cad ||'', ''||rec1.attname||'' numeric(10,3)'';
			   ELSE
			   	IF $2 = rec1.attnum THEN
					cad := cad ||'', ''||rec1.attname||'' numeric(10,3)'';
				ELSE
					cad := cad ||'', ''||rec1.attname||'' ''||rec1.typname;
				END IF;
			   END IF;
			ELSE
			   cad := cad ||'', ''||rec1.attname||'' ''||rec1.typname;
			END IF;
		END IF;	
	END LOOP;	
	
	tabla := $1 || ''n'';
	SELECT INTO flag_val relname FROM pg_class WHERE relname = tabla;
	IF flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE ''||tabla;
	END IF; 
	
	EXECUTE ''COPY ''||$1||'' TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''CREATE TABLE ''||tabla||''(''||cad||'')''; 
	EXECUTE ''COPY ''||tabla||'' FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';


--*** PROCESO DE NORMALIZACION

	sql := ''SELECT attnum,attname,atttypid FROM pg_class, pg_attribute,pg_type''
		|| '' WHERE pg_class.relname = ''''''||tabla||''''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND pg_type.oid=pg_attribute.atttypid AND attnum > 0'';
	
	IF $2 = 0 THEN
			
		FOR rec1 IN EXECUTE sql LOOP				
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 1700 THEN
		
				FOR rec2 IN EXECUTE ''SELECT MAX(''||rec1.attname||'') AS max FROM ''||tabla LOOP
					max := rec2.max;
				END LOOP;
			
				sql2 := ''UPDATE ''||tabla||'' SET ''||rec1.attname
					||''=''||rec1.attname||''/''||max;
				EXECUTE sql2;
			END IF;
		END LOOP;	
	ELSE
		sql := sql || '' AND attnum=''||$2;
		
		FOR rec1 IN EXECUTE sql LOOP	
		END LOOP;	
		FOR rec2 IN EXECUTE ''SELECT MAX(''||rec1.attname||'') AS max FROM ''||tabla LOOP
			max := CAST(rec2.max as numeric(10,3));
		END LOOP;
				
		sql2 := ''UPDATE ''||tabla||'' SET ''||rec1.attname||''=''||rec1.attname||''/''||max;
		
		EXECUTE sql2;		
	END IF;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''fl_''||$1||'''''''' LOOP	
			EXECUTE ''DROP TABLE fl_''||$1;	
		END LOOP;
	EXECUTE ''CREATE TABLE fl_''||$1||'' AS SELECT * FROM ''||tabla;
	EXECUTE ''DROP TABLE ''||tabla;	
	RETURN NEXT ''fl_''||$1;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);