CREATE OR REPLACE FUNCTION view_set(varchar) RETURNS SETOF varchar AS'--TABLA
DECLARE
		
	sql2		text DEFAULT NULL;
	rec1		record;		
	
BEGIN

	FOR rec1 IN EXECUTE ''SELECT att,valor FROM pg_pila WHERE num!=0 AND valor >= 0'' LOOP
			
		IF sql2 ISNULL THEN
			sql2 := CAST(rec1.att as varchar) || ''='' || rec1.valor;	
		ELSE
			sql2 := sql2 || '' AND ''|| CAST(rec1.att as varchar) || ''='' || rec1.valor;
		END IF;			
	END LOOP;
		
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''viewc1'''''' LOOP
		EXECUTE ''DROP VIEW viewc1'';
	END LOOP;		
	
	IF sql2 IS NOT NULL THEN
		sql2 := ''CREATE VIEW viewc1 AS SELECT * FROM ''||$1||'' WHERE ''||sql2;
		
	ELSE	
		sql2 := ''CREATE VIEW viewc1 AS SELECT * FROM ''||$1;
	END IF;
	
	EXECUTE sql2;
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

--subgrupo para los algoritmos C4.5 y Matetree