CREATE OR REPLACE FUNCTION test_sliq(varchar) RETURNS SETOF varchar AS '
DECLARE
	
	cad		text DEFAULT NULL;
	atri		text DEFAULT NULL;
	tabla		text DEFAULT NULL;
	rel		text DEFAULT NULL;
	att		text DEFAULT NULL;
	
	sql1		varchar DEFAULT NULL;	
	sql2		varchar DEFAULT NULL;	
	sql		varchar DEFAULT NULL;	

	rec1		record;
	rec2		record;

	cont		integer;
	at		integer;
	
	
BEGIN
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
	END LOOP;	
	IF rec1.relname IS NOT NULL THEN
		tabla := ''kdd_pru'';
	ELSE
		tabla := ''pg_kdd_tmp'';
	END IF;	
	
	cont := 0;
	at := 1;
	
	FOR rec1 IN EXECUTE ''SELECT n,id,atributo,valor,com,tipo FROM sliq_rules'' LOOP
		
		IF sql ISNULL THEN
			
			cad := at ||'' ''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar);
			
			IF rec1.tipo = 1 THEN   --**2=categorico 1=float
				sql := ''(''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar);	
			ELSE	
				sql := ''(''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)||''''''''||CAST(rec1.valor as varchar)||'''''''';	
			END IF;
			sql2 :=	sql;
		ELSE
			IF rec1.tipo = 1 THEN   --**2=categorico 1=float
				sql := sql || '') AND (''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar);	
			ELSE	
				IF rec1.id = 2 THEN
					IF rec1.com= ''!='' THEN
						sql := sql || '' AND ''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)
						||''''''''||CAST(rec1.valor as varchar)||'''''''';
					ELSE
						sql := sql || '' OR ''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)
						||''''''''||CAST(rec1.valor as varchar)||'''''''';
					END IF;
				ELSE
					sql := sql || '') AND (''||CAST(rec1.atributo as varchar)||CAST(rec1.com as varchar)||''''''''
					||CAST(rec1.valor as varchar)||'''''''';
				END IF;
				
			END IF;
			
			IF CAST(rec1.atributo as varchar) <> $1 THEN
				sql2 := sql ;
			END IF;
			
			IF CAST(rec1.atributo as varchar) = $1 THEN
				sql := sql ||'')'';
				sql2 := sql2 ||'')'';
				
				FOR rec2 IN EXECUTE ''SELECT COUNT(*) AS cc FROM ''||Tabla||'' WHERE ''||sql LOOP
					cont := cont + CAST(rec2.cc as integer);	
					rel := ''[''||CAST(rec2.cc as varchar)||''/'';
				END LOOP;
				sql := NULL;
				
				FOR rec2 IN EXECUTE ''SELECT COUNT(*) AS cc FROM pg_kdd_tmp WHERE ''||sql2 LOOP
					rel := rel||CAST(rec2.cc as varchar)||'']'';
				END LOOP;
				
				cad := cad|| '' --> ''||CAST(rec1.atributo as varchar)
					||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar)
					||''     ''||rel;
					
				RETURN NEXT cad;
				
				cad := NULL;
				
				at := at + 1;
			ELSE
				cad := cad|| '' AND ''||CAST(rec1.atributo as varchar)
					||CAST(rec1.com as varchar)||CAST(rec1.valor as varchar);
				
			END IF;
		END IF;
	END LOOP;
	
	sql := CAST(cont as varchar);
	
	RETURN NEXT ''OK'';
	RETURN NEXT sql;
	
	EXECUTE ''DROP TABLE pg_kdd_tmp'';	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
		EXECUTE ''DROP TABLE kdd_pru'';	
	END LOOP;	
	EXECUTE ''DROP TABLE kdd_ent'';	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

