\connect - postgres

SET search_path = public, pg_catalog;

DROP TABLE public.dar_size;
DROP TABLE public.dar_rasso;
DROP TABLE public.dar_asso;
DROP TABLE public.dar_rcan;
DROP TABLE public.dar_rcanf;
DROP TYPE public.rules CASCADE;
DROP FUNCTION public.size_rules (text);
DROP FUNCTION public.type_rules (character varying);
DROP PROCEDURAL LANGUAGE plpgsql;
DROP FUNCTION public.plpgsql_call_handler ();

-- Name: plpgsql_call_handler (); Type: FUNCTION; Schema: public
--
CREATE FUNCTION plpgsql_call_handler () RETURNS language_handler
    AS '$libdir/plpgsql', 'plpgsql_call_handler'
    LANGUAGE c;

-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: public 
--
CREATE TRUSTED PROCEDURAL LANGUAGE plpgsql HANDLER plpgsql_call_handler;

-- Funtions
--
\i /usr/local/src/postgresql-7.3.4/contrib/kdd/asociacion/size_rules.sql
\i /usr/local/src/postgresql-7.3.4/contrib/kdd/asociacion/type_rules.sql