#ifndef _DEFS_H_
#define _DEFS_H_

#include "postgres.h"
#include "access/heapam.h"
#include "catalog/namespace.h"
#include "utils/builtins.h"

#include "executor/execdebug.h"
#include "parser/parsetree.h"
#include "utils/tuplestore.h"

#include "catalog/heap.h"
#include "catalog/namespace.h"
#include "catalog/pg_type.h"
#include "commands/tablecmds.h"
#include "executor/execdefs.h"
#include "executor/executor.h"
#include "executor/spi.h"	//new

#include "miscadmin.h"
#include "funcapi.h"
#include "utils/syscache.h"
#include "utils/acl.h"
#include "utils/lsyscache.h"

#define LOG_2 0.69314718055994530942

#define nuevoArreglo(tipo,tamano) (tipo *)malloc( (tamano) * sizeof(tipo) );
#define liberar(a) free(a)

#endif
