/*-------------------------------------------------------------------------
 *
 * nodeAssociator.h
 *
 *
 *
 * Portions Copyright (c) 2005, PostgreSQL Muerguanos Development Group
 * Portions Copyright (c) 2005, Regents of the University of Nariño
 *
 * $Id: nodeSeqscan.h,v 1.15 2002/06/20 20:29:49 momjian Exp $
 *
 *-------------------------------------------------------------------------
 */
#ifndef NODEASSOCIATOR_H
#define NODEASSOCIATOR_H

#include "nodes/plannodes.h"

extern TupleTableSlot *ExecAssociator(Associator *node);
extern bool ExecInitAssociator(Associator *node, EState *estate, Plan *parent);
extern int	ExecCountSlotsAssociator(Associator *node);
extern void ExecEndAssociator(Associator *node);

#endif   /* NODEASSOCIATOR_H */
